﻿#include "stdafx.h"
#include "WorkGroupDlg.h"
#include "WorkGroupController.h"
#include "WorkGroupModel.h"
#include "ChatDialogManager.h"
#include "SendNoteMananger.h"
#include "NeMessengerDlg.h"
#include "DialPadManager.h"
#include "main_frame.hpp"
#include "CreateNewGroupWnd.h"

#define BTN_WIDTH				90
#define BTN_HEIGHT				36
#define BTN_GAP_X				4

IMPLEMENT_DYNAMIC(CWorkGroupDlg, CSkinDialog)

CWorkGroupDlg::CWorkGroupDlg(WorkGroupController* pController, WorkGroupModel* pModel, CWnd* pParent /*=NULL*/)
	: CSkinDialog(CNeMessengerDlg::IDD, pParent)	
	, m_pController(pController)
	, m_pModel(pModel)
{
	m_pWGButtons = NULL,
	m_nAddFavoriteGroupID = -1;
	m_pChatDlg = NULL;
	m_pSendMemoDlg = NULL;
	m_eViewType = SHOW_ORG;
	m_pShownTree = &m_treeOrg;
	m_pShownList = &m_lcOrg;
	m_nUserAuth = AUTH_SHOW_NONE;
	m_bTracking = FALSE;
	m_nHitTest = HTNOWHERE;
	m_strSearchText = _T("");
	m_strPreSelectedFavoriteGroup = _T("");
	m_bSortAscending = true;
	m_ePopupMenuType = LIST_POPUP_MENU;
	m_rtSplitter.SetRectEmpty();
	m_rtSplitter.left = DEFAULT_TREE_WIDTH;
	m_rtSplitter.right = m_rtSplitter.left + 10;
	m_rtSplitter.top = POINT_TREE_Y;
	m_bSplitterClicked = false;
	m_bSelectedBySearchResult = false;
	m_bIsSearchResult = false;
	m_strSortCol = _T("");
	m_nSearchLevel = 0;
	m_strSearchDept = _T("");
	
	m_nCursor = CURSOR_DEFAULT;

	// 鼻茄苞 惑包绝捞 公炼扒 焊捞绰 拿烦篮 檬扁俊 蔼阑 且寸
	m_nColStatus = 0;	
	m_nColName = 1;
	m_nColDept = 2;
	m_nColJbps = 3;
	m_nColJbdt = 4;

	// 鼻茄俊 蝶扼 搬沥登绰 拿烦篮 老窜 -1肺 且寸 饶 鼻茄俊 嘎霸 炼沥茄促.
	m_nColIPTPresence = -1;
	m_nColWorkStatus = -1;
	m_nColExtensionTel = -1;
	m_nColCorpTel = -1;
	m_nColCellPhone = -1;
	m_nColFax = -1;
	m_nColEmail = -1;
	m_nColRoamingTel = -1;
	m_nColKeyword = -1;
	m_nColPlace = -1;
	m_nColUserID = -1;
	m_nColJbpsCd = -1;
	m_nColJbdtCd = -1;
	m_nClickItem = -1;
	m_nClickSubItem = -1;

	m_hBmpUserBottom = NULL;
	m_hBmpUserBottomBK = NULL;

	ZeroMemory(&m_sizeUserBottom, sizeof(SIZE));
	ZeroMemory(&m_sizeUserBottomBK, sizeof(SIZE));
    _clipBoardFormat = 0;
    m_nBorderHeight = 0;
    m_nBorderWidth = 0;
}

CWorkGroupDlg::~CWorkGroupDlg()
{	
	m_penBorder.DeleteObject();
	m_bmTopBg.DeleteObject();
	m_ilStatus.DeleteImageList();
	m_ilIPTStatus.DeleteImageList();
	m_ilWorkStatus.DeleteImageList();
}

void CWorkGroupDlg::DoDataExchange(CDataExchange* pDX)
{
	CSkinDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ORG_TREE, m_treeOrg);
	DDX_Control(pDX, IDC_WORKGROUP_TREE, m_treeWorkGroup);
	DDX_Control(pDX, IDC_ORG_LIST, m_lcOrg);
	DDX_Control(pDX, IDC_WORKGROUP_LIST, m_lcWork);
	DDX_Control(pDX, IDC_SHOW_ORG_BUTTON, m_btnORGView);
	DDX_Control(pDX, IDC_SHOW_WORK_GROUP_BUTTON, m_btnWorkGroupView);
	DDX_Control(pDX, IDC_COMBO_PAGE, m_comboPage);
	DDX_Control(pDX, IDC_COMBO_LEVEL, m_comboLevel);	
	DDX_Control(pDX, IDC_PREV_BUTTON, m_btnPrev);
	DDX_Control(pDX, IDC_NEXT_BUTTON, m_btnNext);
}

BEGIN_MESSAGE_MAP(CWorkGroupDlg, CSkinDialog)
	// Window message
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_WM_SIZE()	
	ON_WM_LBUTTONUP()
	ON_WM_NCLBUTTONUP()
	ON_WM_GETMINMAXINFO()
	ON_WM_SETCURSOR()
	ON_WM_TIMER()
	ON_WM_NCHITTEST()
	ON_WM_CREATE()
	// BN_CLICKED
	ON_BN_CLICKED(IDC_SHOW_ORG_BUTTON, &CWorkGroupDlg::OnBnClickedShowOrgButton)
	ON_BN_CLICKED(IDC_SHOW_WORK_GROUP_BUTTON, &CWorkGroupDlg::OnBnClickedShowWorkGroupButton)
	ON_BN_CLICKED(IDC_PREV_BUTTON, &CWorkGroupDlg::OnBnClickedPrevButton)					// 捞傈 其捞瘤
	ON_BN_CLICKED(IDC_NEXT_BUTTON, &CWorkGroupDlg::OnBnClickedNextButton)					// 捞傈 其捞瘤

	// Notify
	ON_NOTIFY(TVN_SELCHANGED, IDC_ORG_TREE, &CWorkGroupDlg::OnTvnSelchangedOrgTree)
	ON_NOTIFY(TVN_SELCHANGED, IDC_WORKGROUP_TREE, &CWorkGroupDlg::OnTvnSelchangedWorkGroupTree)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_ORG_LIST, &CWorkGroupDlg::OnLvnItemchangedOrgList)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_WORKGROUP_LIST, &CWorkGroupDlg::OnLvnItemchangedWorkgroupList)
	ON_NOTIFY(NM_CLICK, IDC_ORG_LIST, &CWorkGroupDlg::OnNMClickList)
	ON_NOTIFY(NM_CLICK, IDC_WORKGROUP_LIST, &CWorkGroupDlg::OnNMClickList)
	ON_NOTIFY(NM_RCLICK, IDC_ORG_TREE, &CWorkGroupDlg::OnNMRClickTree)
	ON_NOTIFY(NM_RCLICK, IDC_WORKGROUP_TREE, &CWorkGroupDlg::OnNMRClickTree)
	ON_NOTIFY(NM_RCLICK, IDC_ORG_LIST, &CWorkGroupDlg::OnNMRClickList)
	ON_NOTIFY(NM_RCLICK, IDC_WORKGROUP_LIST, &CWorkGroupDlg::OnNMRClickList)
	ON_NOTIFY(LVN_BEGINDRAG, IDC_ORG_LIST, &CWorkGroupDlg::OnLvnBegindragList)
	ON_NOTIFY(LVN_BEGINDRAG, IDC_WORKGROUP_LIST, &CWorkGroupDlg::OnLvnBegindragList)
	ON_NOTIFY(LVN_BEGINRDRAG, IDC_ORG_LIST, &CWorkGroupDlg::OnLvnBeginrdragList)	
	ON_NOTIFY(LVN_BEGINRDRAG, IDC_WORKGROUP_LIST, &CWorkGroupDlg::OnLvnBeginrdragList)	
	ON_NOTIFY(NM_DBLCLK, IDC_ORG_LIST, &CWorkGroupDlg::OnNMDblclkList)
	ON_NOTIFY(NM_DBLCLK, IDC_WORKGROUP_LIST, &CWorkGroupDlg::OnNMDblclkList)
	ON_NOTIFY(HDN_ITEMCLICK, 0, &CWorkGroupDlg::OnHdnItemclickList)

	// Command
	ON_COMMAND(ID_MENU_SEND_MEMO, &CWorkGroupDlg::OnMnSendMemo)
	ON_COMMAND(ID_MENU_TREE_SEND_MEMO, &CWorkGroupDlg::OnMnTreeSendMemo)
	ON_COMMAND(ID_MENU_CHAT, &CWorkGroupDlg::OnMnIMInvite)
	ON_COMMAND(ID_MENU_TREE_CHAT, &CWorkGroupDlg::OnMnTreeIMInvite)
	ON_COMMAND(ID_MENU_USER_INFO, &CWorkGroupDlg::OnMnProfile)
	ON_COMMAND(ID_MENU_CREATE_FAVORITE_GROUP, &CWorkGroupDlg::OnMnCreateFavoriteGroup)
	ON_COMMAND(ID_MENU_CHAT_HISTORY, &CWorkGroupDlg::OnMnChatHistory)
	ON_COMMAND_RANGE(WM_USER_ID_TREE, (WM_USER_ID_TREE + 1000), OnMenuTreeFavoriteAdd)
	ON_COMMAND_RANGE(WM_USER_ID_LIST, (WM_USER_ID_LIST + 1000), OnMenuFavoriteButton)
	ON_COMMAND_RANGE(WM_USER_ID_FAVORITE_BUTTON, (WM_USER_ID_FAVORITE_BUTTON + 100), OnMenuFavoriteButton)
	ON_COMMAND_RANGE(ID_MENU_COMPANY_PHONE, ID_MENU_IPT_EXT_PHONE, OnMenuIPT)
	ON_COMMAND(ID_MENU_SMS, &CWorkGroupDlg::OnMenuSms)
	ON_COMMAND(ID_MENU_TREE_SMS, &CWorkGroupDlg::OnMenuTreeSms)

	// On Control
	ON_CBN_SELCHANGE(IDC_COMBO_PAGE, &CWorkGroupDlg::OnCbnSelchangeComboPage)
	ON_CBN_SELCHANGE(IDC_COMBO_LEVEL, &CWorkGroupDlg::OnCbnSelchangeComboLevel)
	ON_MESSAGE(UM_CHAT_GET_STATUS,&CWorkGroupDlg::OnGetUserStatus)
	ON_MESSAGE(UM_GETBUDDY_STATUS,&CWorkGroupDlg::OnGetBuddyStatus)
END_MESSAGE_MAP()

BOOL CWorkGroupDlg::Create(UINT nIDTemplate, CWnd* pParentWnd)
{
	return CSkinDialog::Create(nIDTemplate, pParentWnd);
}

BOOL CWorkGroupDlg::Create(ORGVIEWTYPE eViewType, UINT nIDTemplate, CWnd* pParentWnd)
{
	m_eViewType = eViewType;

	return CSkinDialog::Create(nIDTemplate, pParentWnd);
}

BOOL CWorkGroupDlg::Create(LPCTSTR pszSearchText, UINT nIDTemplate, CWnd* pParentWnd/* = NULL */)
{
	m_strSearchText = pszSearchText;

	return CSkinDialog::Create(nIDTemplate,pParentWnd);
}

BOOL CWorkGroupDlg::OnInitDialog()
{
	CSkinDialog::OnInitDialog();

	// SetIcon() 窃荐 荤侩 陛瘤

	// Dialog狼 Border甫 Resizing 栏肺 林霸登搁 鸥捞撇官狼 酒捞能阑 绝举荐啊 绝促.(SetIcon 悼累 救窃)
	// 弊贰辑 Border甫 Dialog Frame阑 林绢 酒捞能阑 绝局绊, Resizing篮 PreTranslateMessage() 俊辑 流立 备泅窍看促.
	// Resizing捞 登搁辑 鸥捞撇 官狼 酒捞能阑 绝举 荐 乐促搁 秦寸 肺流阑 力芭秦档 公规窍促. 2012.04.11. Jinwoo.Lee
	ModifyStyle(DS_MODALFRAME, WS_THICKFRAME);
	ModifyStyle(0, WS_CLIPCHILDREN);
	ModifyStyle(WS_MAXIMIZEBOX, 0);

	__ResourceLoad(TRUE);

	

	m_nBorderHeight = (GetSystemMetrics(SM_CYCAPTION) + GetSystemMetrics(SM_CYFRAME)) + 3;
	m_nBorderWidth = GetSystemMetrics(SM_CXFRAME);

	SetUserAuth();
	
	SetExitBtnActHide(FALSE); 
	SetWindowText(LoadStringFromResource(IDS_STRING260));	// 炼流档/诀公弊缝
	SetShowTitle(FALSE);

	SetDialogShowWindowText(true);
	SetDialogWindowText(LoadStringFromResource(IDS_STRING260));
	SetWindowTextColor(CColorConvert::HEX2Color(0xFFC8D1D8));
	SetWindowTextFontHeight(12);
	GET_APP()->SetWindowRegion(this);

	InitTreeCtrl();
	InitTab();
	InitListCtrl();
	InitPageCtrls();

	// 皋牢芒 焊歹 祸
	m_penBorder.CreatePen(PS_SOLID, 1, COLOR_LIST_BORDER);

	// 母记官 酒贰狼 弊扼单捞记 硅版 捞固瘤
	LoadBitmapFromPath(m_bmTopBg, GetAppImgFile(_T("frame_B_bg.png")));

	// 惑窜 八祸 俊叼飘/滚瓢
	CString strTmpClassName;
	strTmpClassName.Format(_T("Ntalk_WorkDlg_Search_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	RegisterWindowClass(strTmpClassName);

	CRect rtWorkSearch(0, 0, 0, 0);
	if (m_wndSearch.Create(strTmpClassName, _T("Ntalk_WorkDlg_Search"), WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS, rtWorkSearch, this, ID_WORK_SEARCH))
	{
		//m_wndSearch.SetImgBGPath(_T("New_Info_Search_BG.png"));
		m_wndSearch.SetImgSearchPath(_T("New_Info_Search.png"), _T("New_Info_Search_Over.png"), _T("New_Info_Search_Click.png"));
		m_wndSearch.SetDefaultText(LoadStringFromResource(IDS_STRING245));
		m_wndSearch.SetImgBGPath(_T("Main_searchform_bg.png"));
		m_wndSearch.SetEditFont(&g_ftDefault9PT);
		m_wndSearch.SetEditBkColor(RGB(255, 255, 255));
		//m_wndSearch.SetEditPosTopY(4);

		if (m_strSearchText.IsEmpty())
			m_wndSearch.SetIntroducingText();	// 八祸绢甫 涝仿秦林技夸.
		else 
			m_wndSearch.SetIntroducingText(m_strSearchText);

		m_wndSearch.SetSearchText(m_strSearchText);
		m_wndSearch.SetResetSearchText(FALSE);		// 八祸 饶 八祸绢甫 檬扁拳 窍瘤 臼澜
        m_wndSearch.SetToolTipText(LoadStringFromResource(IDS_STRING_MAIN_TOOLTIP_17));
	}

	_clipBoardFormat = RegisterClipboardFormat(_T("CF_NTALK_ID"));

	ShowCmd(m_eViewType);

	if (GetViewType() == SHOW_SEARCH)
		MoveWindow(0, 0, 500, 500);
	else
		MoveWindow(0, 0, 800, 500);
	CenterWindow();

	//SetSkin();
	ReSizeCtrl();
	
	//ModifyStyleEx(0, WS_EX_LAYERED);

	SetLastPositionAndSize(this, _T("WorkGroupDialog"));
	RedrawWindow();
	
	return TRUE;
}

void CWorkGroupDlg::SetSkin()
{
	CXTPSkinManager* pSkinManager = XTPSkinManager();

	//pSkinManager->Remove(m_lcOrg.GetSafeHwnd());	// ListCtrl篮 胶挪阑 静瘤 臼绊 流立 弊赴促
	//pSkinManager->Remove(m_lcWork.GetSafeHwnd());
	pSkinManager->ApplyWindow(GetSafeHwnd());

	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("WorkGroupDlg.ini"));
	pSkinManager->SetWindowTheme(GetSafeHwnd(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CWorkGroupDlg::FreeTreeItemData(CTreeCtrl *pTreeCtrl, HTREEITEM hItem)
{
	while (hItem)
	{
		if (pTreeCtrl->ItemHasChildren(hItem))
			FreeTreeItemData(pTreeCtrl, pTreeCtrl->GetChildItem(hItem));

		COrgTreeData *pTreeData = (COrgTreeData *)pTreeCtrl->GetItemData(hItem);

		if (pTreeData)
			delete pTreeData;

		pTreeCtrl->SetItemData(hItem, NULL);

		hItem = pTreeCtrl->GetNextSiblingItem(hItem);
	}
}

HTREEITEM CWorkGroupDlg::FindTreeItem(CTreeCtrl *pTreeCtrl, HTREEITEM hItem, CString strDeptId)
{
	while (hItem)
	{
		if (pTreeCtrl->ItemHasChildren(hItem))
		{
			HTREEITEM hFindItem = FindTreeItem(pTreeCtrl, pTreeCtrl->GetChildItem(hItem), strDeptId);

			if (hFindItem != NULL)
				return hFindItem;
		}

		COrgTreeData *pTreeData = (COrgTreeData *)pTreeCtrl->GetItemData(hItem);

		if (!pTreeData)
			continue;

		if (pTreeData->GetID().CompareNoCase(strDeptId) == 0)
			return hItem;

		hItem = pTreeCtrl->GetNextSiblingItem(hItem);
	}

	return NULL;
}

void CWorkGroupDlg::SetViewType(ORGVIEWTYPE eViewType)
{
	m_eViewType = eViewType;
}

ORGVIEWTYPE CWorkGroupDlg::GetViewType()
{
	return m_eViewType;
}

BOOL CWorkGroupDlg::OnEraseBkgnd(CDC* pDC)
{
	FUNCTION_BLOCK_TRACE(50);
	//return TRUE;
	if(pDC == NULL)
	{
		return FALSE;
	}


	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	NMMemDC memDC;
	memDC.CreateCompatibleDC(pDC, &rcClient);
	memDC.FillSolidRect(0, 0, rcClient.Width(), rcClient.Height(), RGB(255, 255, 255));	// 措拳惑磊 硅版祸

	// 惑窜狼 捞固瘤
	BITMAP bitmap;
	m_bmTopBg.GetBitmap(&bitmap);

	NMMemDC memBmpDC;
	memBmpDC.CreateCompatibleDC(pDC, bitmap.bmWidth, bitmap.bmHeight);

	CBitmap *pOldBmp = memBmpDC.SelectObject(&m_bmTopBg);
	memDC.StretchBlt(0, 0, rcClient.Width(), bitmap.bmHeight, &memBmpDC, 0, 0, bitmap.bmWidth, bitmap.bmHeight, SRCCOPY);
	memBmpDC.SelectObject(pOldBmp);

	// Search wnd 甫 皋牢芒 巴阑 鞍捞 荤侩窍促焊聪 谅快 扼牢捞 绝栏骨肺 弊妨霖促.
	CRect rcSearch(0, 0, 0, 0);
	m_wndSearch.GetWindowRect(rcSearch);
	this->ScreenToClient(rcSearch);
	rcSearch.InflateRect(1, 0, 1, -1);

	memDC.FillSolidRect(rcSearch.left, rcSearch.top, rcSearch.Width(), rcSearch.Height(), RGB(213,213,213));

	CPen *pOldPen = memDC.SelectObject(&m_penBorder);
	memDC.SelectObject((HBRUSH)GetStockObject(NULL_BRUSH));

	// Listctrl狼 硅版急
	CRect rcList(0, 0, 0, 0);
	m_lcOrg.GetWindowRect(&rcList);
	ScreenToClient(rcList);
	rcList.InflateRect(1, 1, 1, 1);
	memDC.Rectangle(rcList);

	// 窍窜 啊肺急
	memDC.MoveTo(0, rcClient.bottom - BTN_HEIGHT - 17);
	memDC.LineTo(rcClient.right, rcClient.bottom - BTN_HEIGHT - 17);

	if (HasAuth(AUTH_LEVEL_SEARCH))
	{
		CRect rcCombo(0, 0, 0, 0);
		m_comboLevel.GetWindowRect(rcCombo);
		ScreenToClient(&rcCombo);
		rcCombo.InflateRect(1, 1, 1, 1);
		memDC.Rectangle(&rcCombo);
	}

	// 炼流档甫 杭 鼻茄捞 乐绰 荤侩磊俊霸父 飘府啊 畴免等促
	if (HasAuth(AUTH_SHOW_ORG_TREE) || HasAuth(AUTH_SHOW_ORG_TREE))
	{
		// 飘府/府胶飘 备盒 技肺急
		memDC.MoveTo(POINT_TREE_X + m_rtSplitter.left, POINT_TREE_Y);
		memDC.LineTo(POINT_TREE_X + m_rtSplitter.left, rcClient.bottom - BTN_HEIGHT - 17);
	}

	pDC->BitBlt(0, 0, rcClient.Width(), rcClient.Height(), &memDC, 0, 0, SRCCOPY);
	memDC.SelectObject(pOldPen);

	return TRUE;
}

void CWorkGroupDlg::OnPaint()
{
	CPaintDC dc(this);

	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);

	CRect rcList(0, 0, 0, 0);
	m_lcOrg.GetWindowRect(&rcList);
	ScreenToClient(rcList);

	// OnPaint俊辑 弊副 康开篮 府胶飘 牧飘费 困率狼 其捞瘤 沥焊 挥捞骨肺 捞 何盒父 康开阑 棱绰促.
	CRect rcPaint = rcList;
	rcPaint.top = POINT_TREE_Y + 1;
	rcPaint.bottom = rcList.top - 1;

	NMMemDC memDC;
	memDC.CreateCompatibleDC(&dc, &rcPaint);
	memDC.FillSolidRect(0, 0, rcPaint.Width(), rcPaint.Height(), RGB(255, 255, 255));	// 措拳惑磊 硅版祸

	if (m_bIsSearchResult)
	{
		CPen *pOldPen = memDC.SelectObject(&m_penBorder);

		// 霓焊冠胶绰 八祸 咯何俊 蝶扼 荐矫肺 Show/Hide啊 登扁 锭巩俊 OnEraseBkgnd俊辑 弊府搁 儡惑捞 巢栏骨肺
		// OnPaint俊辑 弊赴促.
		CRect rcCombo(0, 0, 0, 0);
		m_comboPage.GetWindowRect(rcCombo);
		rcCombo.MoveToXY(rcPaint.Width() - POINT_PAGE_COMBO_X + 11, POINT_PAGE_COMBO_Y - 36);
		rcCombo.InflateRect(1, 1, 1, 1);
		memDC.Rectangle(&rcCombo);

		CFont *pOldFont = memDC.SelectObject(&g_ftDefault9PT);
		memDC.SetTextColor(COLOR_NORMAL_TEXT);
		memDC.SetBkMode(TRANSPARENT);

		CRect rcList(0, 0, 0, 0);
		m_lcOrg.GetWindowRect(&rcList);
		ScreenToClient(rcList);

		CRect rcDept(0, 0, 0, 0);
		rcDept.SetRect(0, 12, rcPaint.Width(), rcPaint.Height());

		// 八祸 扒荐 钎矫
		CString strSearchTotal;
		strSearchTotal.Format(LoadStringFromResource(IDS_STRING482), m_pModel->GetSearchTotal());

		CString strSearchDept;
//		if (m_strSearchDept.IsEmpty())
			strSearchDept.Format(LoadStringFromResource(IDS_STRING483));
//		else
//			strSearchDept.Format(_T("\'%s\'"), m_strSearchDept);

		CString strSearchResult;
		strSearchResult.Format(_T("%s %s (%d/%d %s)"), strSearchDept, strSearchTotal, m_pModel->GetSearchPage(), (m_pModel->GetSearchTotal() / PAGE_SIZE) + 1, LoadStringFromResource(IDS_STRING484));
		memDC.DrawText(strSearchResult, &rcDept, DT_LEFT | DT_TOP | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX);

		CRect rcPrevNext = rcDept;
		rcPrevNext.right -= 22;
		rcPrevNext.left = rcPrevNext.right - 76;
		CString strPrevNext;
		strPrevNext.Format(_T("%s | %s"), LoadStringFromResource(IDS_STRING485), LoadStringFromResource(IDS_STRING486));
		memDC.DrawText(strPrevNext, rcPrevNext, DT_CENTER | DT_TOP | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX);

		CRect rcPage = rcDept;
		rcPage.right -= 200;
		rcPage.left = rcPage.right - 50;
		memDC.DrawText(LoadStringFromResource(IDS_STRING484), rcPage, DT_RIGHT | DT_TOP | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX);

		dc.BitBlt(rcPaint.left, rcPaint.top, rcPaint.Width(), rcPaint.Height(), &memDC, 0, 0, SRCCOPY);

		memDC.SelectObject(pOldFont);
		memDC.SelectObject(pOldPen);
	}
	else
	{
		// 何辑疙 免仿
		HTREEITEM hItem = m_pShownTree->GetSelectedItem();

		if (hItem)
		{
			CString strDept = m_pShownTree->GetItemText(hItem);

			CFont *pOldFont = memDC.SelectObject(&g_ftDefault9PT);
			memDC.SetTextColor(COLOR_NORMAL_TEXT);
			memDC.SetBkMode(TRANSPARENT);

			CRect rcDept(0, 0, 0, 0);
			rcDept.SetRect(0, 12, rcPaint.Width(), rcPaint.Height());
			memDC.DrawText(strDept, &rcDept, DT_LEFT | DT_TOP | DT_SINGLELINE | DT_END_ELLIPSIS | DT_NOPREFIX);

			dc.BitBlt(rcPaint.left, rcPaint.top, rcPaint.Width(), rcPaint.Height(), &memDC, 0, 0, SRCCOPY);

			memDC.SelectObject(pOldFont);
		}
	}
	CSkinDialog::OnPaint();
}

void CWorkGroupDlg::ShowCmd(ORGVIEWTYPE ViewType)
{
	if (ViewType == SHOW_ORG)
	{
		m_treeWorkGroup.ShowWindow(SW_HIDE);
		m_treeOrg.ShowWindow(SW_SHOW);
		m_pShownTree = &m_treeOrg;	// 货酚霸 焊咯龙 飘府狼 器牢磐甫 且寸茄促. 

		m_lcWork.ShowWindow(SW_HIDE);
		m_lcOrg.ShowWindow(SW_SHOW);
		m_pShownList = &m_lcOrg;

		m_btnWorkGroupView.SetTapUnSelected();
		m_btnORGView.SetTapSelected();

		// 飘府俊 畴靛啊 窍唱档 绝阑 版快父 辑滚俊辑 啊廉柯促. 畴靛啊 乐阑 版快绰 捞固 啊廉柯 巴栏肺 魄窜茄促.
		if (m_treeOrg.GetCount() == 0)
		{
			if (HasAuth(AUTH_SHOW_ORG_TREE))
			{
				m_pController->RequestORGGroup(ADD_WORKORGGROUP);
			}
		}
	}
	else if (ViewType == SHOW_WORKGROUP)
	{
		m_treeOrg.ShowWindow(SW_HIDE);
		m_treeWorkGroup.ShowWindow(SW_SHOW);
		m_pShownTree = &m_treeWorkGroup;

		m_lcOrg.ShowWindow(SW_HIDE);
		m_lcWork.ShowWindow(SW_SHOW);
		m_pShownList = &m_lcWork;

		m_btnORGView.SetTapUnSelected();
		m_btnWorkGroupView.SetTapSelected();

		if (m_treeWorkGroup.GetCount() == 0)
		{
			if (HasAuth(AUTH_SHOW_WORK_TREE))
			{
				m_pController->RequestWorkGroup();
			}
		}
	}
	else if (ViewType == SHOW_SEARCH)
	{
		m_treeOrg.ShowWindow(SW_HIDE);
		m_treeWorkGroup.ShowWindow(SW_HIDE);
		m_pShownTree = &m_treeOrg;	// 飘府绰 角力 焊捞柳 臼瘤父 抗寇惑炔阑 规瘤窍扁 困秦 且寸茄促.

		m_lcWork.ShowWindow(SW_HIDE);
		m_lcOrg.ShowWindow(SW_SHOW);
		m_pShownList = &m_lcOrg;
	}
}

void CWorkGroupDlg::DoSearch(CString strSearchText)
{
	strSearchText = strSearchText.Trim(_T("% "));	// 菊第狼 %客 傍归 巩磊绰 力芭茄促.

	if (strSearchText.GetLength() < 2)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING169));

		m_wndSearch.SetIntroducingText(m_wndSearch.GetSearchText());
		
		return;
	}

	m_wndSearch.SetIntroducingText(strSearchText);
	m_wndSearch.SetSearchText(strSearchText);

	m_searchParam.strSearchText = strSearchText;
	m_searchParam.strFunction = GET_CONFIG()->GetFunctionList();
	CString strLangCode = GetLanguageStringUnicode();
	m_searchParam.strLangCode = strLangCode;
	m_searchParam.strDeptId = L"";

	CString strVal;	// RequestNameSearchList() 龋免矫鳖瘤 函荐啊 蜡瓤秦具茄促.(酒贰狼 if 巩 救栏肺 持栏搁 救凳)

	// 饭骇喊 八祸 鼻茄捞 乐绰 版快 急琶等 饭骇阑 傈崔
	if (HasAuth(AUTH_LEVEL_SEARCH))
	{
		strVal.Format(_T("%d"), m_nSearchLevel);
		m_searchParam.strLevel = strVal;
	}

	// 窍困何辑 八祸阑 困秦 泅犁 急琶等 何辑ID甫 傈崔
	HTREEITEM hItem = m_pShownTree->GetSelectedItem();

	if (hItem)
	{
		COrgTreeData *pTreeData = (COrgTreeData *)m_pShownTree->GetItemData(hItem);

		if (pTreeData)
			m_searchParam.strDeptId = pTreeData->GetID();
	}

	m_pController->RequestNameSearchList(m_searchParam);

	m_strSearchText = strSearchText;

}

void CWorkGroupDlg::OnBnClickedMemoButton()
{
	SendMemo();
}

void CWorkGroupDlg::OnBnClickedChatButton()
{
	InviteIM();
}

void CWorkGroupDlg::OnBnClickedShowWorkGroupButton()
{
	SetViewType(SHOW_WORKGROUP);
	ShowCmd(SHOW_WORKGROUP);
}

void CWorkGroupDlg::OnBnClickedShowOrgButton()
{
	SetViewType(SHOW_ORG);
	ShowCmd(SHOW_ORG);
}

void CWorkGroupDlg::OnBnClickedPrevButton()
{
	int nCurrentPage = m_pModel->GetSearchPage();

	if (nCurrentPage > 1)
	{
		if (!m_strSearchText.IsEmpty())
		{
			m_searchParam.clear();
			m_searchParam.nPage = nCurrentPage - 1;
			m_searchParam.strSortCol = m_strSortCol;
			m_bSortAscending ? m_searchParam.strSortAsc = L"asc" : m_searchParam.strSortAsc = L"desc";

			DoSearch(m_strSearchText);
		}
	}
}

void CWorkGroupDlg::OnBnClickedNextButton()
{
	int nTotalPage = (m_pModel->GetSearchTotal() / PAGE_SIZE) + 1;
	int nCurrentPage = m_pModel->GetSearchPage();

	if (nCurrentPage < nTotalPage)
	{
		if (!m_strSearchText.IsEmpty())
		{
			m_searchParam.clear();
			m_searchParam.nPage = nCurrentPage + 1;
			m_searchParam.strSortCol = m_strSortCol;
			m_bSortAscending ? m_searchParam.strSortAsc = L"asc" : m_searchParam.strSortAsc = L"desc";

			DoSearch(m_strSearchText);
		}
	}
}

void CWorkGroupDlg::GetSelectedUserIDList(CStringList &selectedIdList)
{
	POSITION pos = m_pShownList->GetFirstSelectedItemPosition();

	while (pos)
	{
		int nIndex = m_pShownList->GetNextSelectedItem(pos);
		CString strID = m_pShownList->GetItemText(nIndex, m_nColUserID);

		if (m_pController->IsMyID(strID))
			continue;

		selectedIdList.AddTail(strID);
	}
}

void CWorkGroupDlg::OnBnClickedFavoriteAddButton()
{
	if (m_pShownList->GetSelectedCount() == 0)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING218));

		return;
	}

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();

	// 榴败茫扁 弊缝捞 绝阑 版快 脚痹肺 积己窍咯 磊悼 殿废茄促.
	if (nGroupCount == 0)
	{
		OnMnCreateFavoriteGroup();
		return;
	}

	CStringList selectedIdList;
	GetSelectedUserIDList(selectedIdList);	// 急琶等 荤侩磊ID 府胶飘

	// 榴败茫扁 府胶飘 急琶 促捞倔肺弊
	CFavoriteListDlg favoriteDlg(this);
	m_GroupList.clear();
	int nMenuIndex = 0;

	for (size_t i = 0; i < nGroupCount; i++)
	{
		const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);

		if (!pGroup)
			continue;

		CString strGroupName = pGroup->GetName();
		int nGroupID = pGroup->GetID();

		// 傈眉 措惑 府胶飘甫 啊廉客辑
		// 茄疙捞扼档 殿废登瘤 臼篮 弊缝疙父 眠啊
		if (!IsAllIdsInBuddyGroup(selectedIdList, nGroupID))	// 急琶等 措惑磊 府胶飘 吝 榴败茫扁 弊缝 救俊 绝绰 荤恩捞 茄疙捞扼档 乐阑 版快
		{
			m_GroupList.insert(std::make_pair(WM_USER_ID_FAVORITE_BUTTON + nMenuIndex++, nGroupID));
			favoriteDlg.InsertFavoriteItem(strGroupName);
		}
	}

	// 捞傈俊 急琶沁带 弊缝疙阑 扁夯栏肺 汲沥秦霖促.
	favoriteDlg.SetDefaultSelectGroup(m_strPreSelectedFavoriteGroup);

    GET_MESSENGER_DLG()->RegisterMfcModalDlg(&favoriteDlg);
    int nRet = favoriteDlg.DoModal();
    GET_MESSENGER_DLG()->UnRegisterMfcModalDlg(&favoriteDlg);

	if (nRet == IDOK)
	{

		nGroupCount = g_pMessengerActor->GetBuddyGroupCount();

		// 趣矫 措拳惑措 眠啊 芒捞 夺 惑怕俊辑 弊缝捞 葛滴 昏力登菌阑 版快 脚痹肺 积己窍咯 殿废茄促.
		if (nGroupCount == 0)
		{
			OnMnCreateFavoriteGroup();
			return;
		}

		int nSelGroup = favoriteDlg.GetSelectedItemIndex();

		if (nSelGroup >= 0)
		{
			m_strPreSelectedFavoriteGroup = favoriteDlg.GetSelectedGroupName();
			OnMenuFavoriteButton(WM_USER_ID_FAVORITE_BUTTON + nSelGroup);
		}
	}

}

BOOL CWorkGroupDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN)
		{
			CString strSearchText = m_wndSearch.GetSearchText();
			
			if (!strSearchText.IsEmpty())
			{
				m_searchParam.clear();
				m_bSortAscending = true;
				DoSearch(strSearchText);
			}

			return TRUE;
		}
		else if (GetKeyState(VK_CONTROL) < 0)
		{
            if (pMsg->wParam == 'A' || pMsg->wParam == 'a')    	// CTRL + A
            {
                m_pShownList->SelectAll();
                return TRUE;
            }
            if (pMsg->wParam == 'F' || pMsg->wParam == 'f')     // CTRL + F
            {
                m_wndSearch.SetEditSearch(TRUE);//SetFocus();
            }
		}
		else if (pMsg->wParam == VK_ESCAPE)
		{
			GET_MESSENGER_DLG()->GetProfileDlgController()->CloseProfileDlg();
		}
	}
	else if (IsCloseMsg(pMsg))
	{
		if (pMsg->hwnd == this->GetSafeHwnd())
		{
			g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ORGCHARTDLG);
			m_pController->Closeview();
			return TRUE;
		}
	}

	//return CSkinDialog::PreTranslateMessage(pMsg);
	// Resizing 阑 荐悼栏肺 贸府秦霖促.
	else if (pMsg->message == WM_NCLBUTTONDOWN ||
			 pMsg->message == WM_NCMOUSEMOVE ||
			 pMsg->message == WM_LBUTTONUP ||
			 pMsg->message == WM_NCLBUTTONUP ||
			 pMsg->message == WM_MOUSEMOVE ||
			 pMsg->message == WM_LBUTTONDOWN)
	{
		CRect rcWnd(0, 0, 0, 0);
		GetWindowRect(&rcWnd);

		switch (pMsg->message)
		{
		case WM_NCLBUTTONDOWN:
			{
				if (pMsg->wParam >= HTLEFT && pMsg->wParam <= HTBOTTOMRIGHT)
				{
					SetCapture();
					m_nHitTest = pMsg->wParam;
				}
			}
			break;

		case WM_LBUTTONDOWN:
			{
				if (m_nCursor == CURSOR_HSPLITTER)
				{
					SetCapture();
					m_bSplitterClicked = true;
				}
			}
			break;

		case WM_MOUSEMOVE:
		case WM_NCMOUSEMOVE:
			{
				// 府荤捞隆, 付快胶 目辑 函版 殿狼 累诀 贸府
				MouseMove(pMsg, rcWnd);
			}
			break;

		case WM_LBUTTONUP:
		case WM_NCLBUTTONUP:
			if (m_nHitTest >= HTLEFT && m_nHitTest <= HTBOTTOMRIGHT)
			{
				ReleaseCapture();
				m_nHitTest = HTNOWHERE;
			}
			else if (m_bSplitterClicked == true)
			{
				ReleaseCapture();
				m_bSplitterClicked = false;
				m_nCursor = CURSOR_DEFAULT;
			}
			break;
		}
	}

	return CSkinDialog::PreTranslateMessage(pMsg);
}

void CWorkGroupDlg::OnNMRClickTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);	
	m_pShownTree->ScreenToClient(&pt);
	UINT uFlags = 0;

	HTREEITEM hItem = m_pShownTree->HitTest(pt, &uFlags);

	if (!hItem)
		return;

	m_pShownTree->Select(hItem, TVGN_CARET);

	PopupMenuView(IDR_MEMU_COMMON_MENU, TREE_POPUP_MENU);
	*pResult = 0;
}

void CWorkGroupDlg::OnNMRClickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	CPoint point(pNMItemActivate->ptAction);

	UINT uFlags = 0;
	m_nClickItem = pNMItemActivate->iItem;
	m_nClickSubItem = pNMItemActivate->iSubItem;

	m_pShownList->HitTest(point, &uFlags);
	if (!(uFlags & LVHT_ONITEM))
		return;

	PopupMenuView(IDR_MEMU_COMMON_MENU, LIST_POPUP_MENU);
	*pResult = 0;
}

void CWorkGroupDlg::OnTvnSelchangedOrgTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	COrgTreeData *pTreeData = (COrgTreeData *)m_treeOrg.GetItemData(pNMTreeView->itemNew.hItem);

	if (pTreeData == NULL)
		return;

/*
	m_strSearchDept = m_treeOrg.GetItemText(pNMTreeView->itemNew.hItem);
	CString strDeptSearchHelp;
	strDeptSearchHelp.Format(LoadStringFromResource(IDS_STRING487), m_strSearchDept);
	m_wndSearch.SetIntroducingText(strDeptSearchHelp);
	m_wndSearch.ShowIntroducingText();
*/

	// 八祸 搬苞肺 秦寸 飘府狼 酒捞袍阑 急琶茄 版快绰 糕滚 府胶飘甫 盎脚窍搁 救等促.
	if (m_bSelectedBySearchResult)
	{
		m_bSelectedBySearchResult = false;
		return;
	}

	m_pController->RequestORGGroupMemberList(pTreeData->GetParentID(), pTreeData->GetID(), UPDATE_VIEW_DETAIL_ORG);

	*pResult = 0;
}

void CWorkGroupDlg::OnTvnSelchangedWorkGroupTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	COrgTreeData *pTreeData = (COrgTreeData *)m_treeWorkGroup.GetItemData(pNMTreeView->itemNew.hItem);

	if (pTreeData == NULL)
		return;

/*
	m_strSearchDept = m_treeWorkGroup.GetItemText(pNMTreeView->itemNew.hItem);
	CString strDeptSearchHelp;
	strDeptSearchHelp.Format(LoadStringFromResource(IDS_STRING487), m_strSearchDept);
	m_wndSearch.SetIntroducingText(strDeptSearchHelp);
	m_wndSearch.ShowIntroducingText();
*/

	// 八祸 搬苞肺 秦寸 飘府狼 酒捞袍阑 急琶茄 版快绰 糕滚 府胶飘甫 盎脚窍搁 救等促.
	if (m_bSelectedBySearchResult)
	{
		m_bSelectedBySearchResult = false;
		return;
	}

	m_pController->RequestWorkGroupMemberList(pTreeData->GetParentID(), pTreeData->GetID());

	*pResult = 0;
}

void CWorkGroupDlg::PopupMenuView(int nMain,int nSub)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);

	CMenu menuList;
	menuList.LoadMenu(nMain);
	m_ePopupMenuType = (ePOPUP_TYPE)nSub;

	if (nSub == TREE_POPUP_MENU || nSub == LIST_POPUP_MENU)
	{
		MakeFavoriteMenu(&menuList, nSub);
		menuList.GetSubMenu(nSub)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);
	}
}

void CWorkGroupDlg::MakeFavoriteMenu(CMenu* menu, int nSub)
{
	const UINT favoriteMenuIndex = 7;
	// 榴败茫扁 弊缝 府胶飘(悼利栏肺 积己)
	CMenu menuFavoriteList;

	if (!menuFavoriteList.CreatePopupMenu())
		return;

	// 扁夯 皋春(榴败茫扁 府胶飘甫 嘿老 何葛 皋春)
	CMenu* pPopup = menu->GetSubMenu(nSub);

	if (!pPopup)
		return;

	pPopup->DeleteMenu(0,MF_BYPOSITION);
	pPopup->DeleteMenu(0,MF_BYPOSITION);
	int nSelectedCount = m_pShownList->GetSelectedCount();

	if (nSelectedCount != 1)
	{
		//pPopup->EnableMenuItem(ID_MENU_USER_INFO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 荤侩磊 沥焊
		pPopup->EnableMenuItem(ID_MENU_CHAT_HISTORY, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 措拳 郴开 焊扁
	}

// 	if (GET_CONFIG()->EnableFunction(_T("UI_03")) == FALSE)
// 		pPopup->EnableMenuItem(ID_MENU_USER_INFO, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);

#ifdef _DEBUG
#else
	if(GET_CONFIG()->EnableFunction(_T("ME_01")) == FALSE)
		pPopup->EnableMenuItem(ID_MENU_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
	
	if(GET_CONFIG()->EnableFunction(_T("ME_01")) == FALSE)
		pPopup->EnableMenuItem(ID_MENU_TREE_SMS, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
#endif

	m_GroupList.clear();

	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;	// 模备眠啊啊 啊瓷茄 榴败茫扁 弊缝 俺荐
										// 弊缝 救俊 荤侩磊啊 殿废登绢 乐瘤 臼篮 版快父 季促.
	int nMenuIndex = 0;

	if (nGroupCount > 0)
	{
		CStringList selectedIdList;
		GetSelectedUserIDList(selectedIdList);	// 急琶等 荤侩磊ID 府胶飘

		// 榴败茫扁 弊缝
		for (size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);

			CString strGroupName = pGroup->GetName();
			int nGroupID = pGroup->GetID();

			if (nSub == TREE_POPUP_MENU)
			{
				m_GroupList.insert(std::make_pair(WM_USER_ID_TREE + i, nGroupID));
				menuFavoriteList.AppendMenu(MF_STRING, WM_USER_ID_TREE + i, strGroupName);
			}
			else if (nSub == LIST_POPUP_MENU)
			{
				// 傈眉 措惑 府胶飘甫 啊廉客辑
				// 茄疙捞扼档 殿废登瘤 臼篮 弊缝疙父 眠啊
				if (!IsAllIdsInBuddyGroup(selectedIdList, nGroupID))	// 急琶等 措惑磊 府胶飘 吝 榴败茫扁 弊缝 救俊 绝绰 荤恩捞 茄疙捞扼档 乐阑 版快
				{
					m_GroupList.insert(std::make_pair(WM_USER_ID_LIST + nMenuIndex, nGroupID));
					menuFavoriteList.AppendMenu(MF_STRING, WM_USER_ID_LIST + nMenuIndex++, strGroupName);
					nAddableBuddyGroupCount++;
				}
			}
		}
	}

	// 弊缝眠啊 皋春 眠啊
	menuFavoriteList.AppendMenu(MF_STRING, ID_MENU_CREATE_FAVORITE_GROUP, LoadStringFromResource(IDS_STRING261));

	//pPopup->AppendMenu(MF_POPUP, (UINT_PTR)menuFavoriteList.m_hMenu, LoadStringFromResource(IDS_STRING262));	// 措拳惑措 眠啊
	pPopup->InsertMenu(favoriteMenuIndex, MF_BYPOSITION | MF_POPUP, (UINT_PTR)menuFavoriteList.m_hMenu, LoadStringFromResource(IDS_STRING262));	// 措拳惑措 眠啊

	// 柯扼牢 惑怕狼 荤侩磊啊 绝阑 版快绰 '措拳窍扁'甫 Disable 惑怕肺 函版茄促.
	// 飘府狼 版快 惑怕蔼捞 词霸 诀单捞飘 登扁 锭巩俊 老窜 劝己拳 矫难初绊 荤侩磊啊 急琶且 版快 贸府窍绰 荐观俊 绝促. 
	// 困客 鞍篮 备泅惑狼 巩力肺 飘府俊辑狼 '措拳窍扁'绰 Spec out. (2012.04.20)
	if (nSub == LIST_POPUP_MENU)
	{
		int nOnlineUserCount = m_pShownList->GetOnlineUserCount(false);

		if (IsSelectMyself())	// 郴 磊脚档 器窃登绢 急琶登绢 乐促搁 柯扼牢 荤侩磊 荐俊辑 1阑 哗霖促.
			nOnlineUserCount -= 1;

		// 唱 磊脚父 急琶等 版快
		if (nSelectedCount == 1 && IsSelectMyself())
		{
			pPopup->EnableMenuItem(ID_MENU_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 措拳窍扁
			pPopup->EnableMenuItem(favoriteMenuIndex, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 榴败茫扁
		}
		else if (nOnlineUserCount <= 0)
		{
			pPopup->EnableMenuItem(ID_MENU_CHAT, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);	// 措拳窍扁
		}
		
		//Modify by sevin for bts:NTALKCL-1165
		//if (nGroupCount > 0 && nAddableBuddyGroupCount == 0)	// nGroupCount捞 1 捞惑牢 版快绰 榴败茫扁 弊缝 积己 皋春啊 焊咯具 窃
		//	pPopup->EnableMenuItem(favoriteMenuIndex, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 榴败茫扁


		if (HasAuth(AUTH_SHOW_IPT))
		{
			if (nSelectedCount != 1)
			{
				pPopup->EnableMenuItem(5, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 傈拳
			}
			else
			{
				POSITION pos = m_pShownList->GetFirstSelectedItemPosition();
				int nSelectedItem = m_pShownList->GetNextSelectedItem(pos);

				CString strUserID = m_pShownList->GetItemText(nSelectedItem, m_nColUserID);

				if (m_pController->IsMyID(strUserID))
				{
					pPopup->EnableMenuItem(5, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);	// 傈拳
				}
				else
				{
					NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
					NTIPTStatusType iptStatusOfBuddy = m_pModel->GetMemberIPTStatus(strUserID);

					CString strCorpTel = m_pShownList->GetItemText(nSelectedItem, m_nColCorpTel);
					CString strCellPhone = m_pShownList->GetItemText(nSelectedItem, m_nColCellPhone);
					CString strExtensionTel = m_pShownList->GetItemText(nSelectedItem, m_nColExtensionTel);

					pPopup->InsertMenu(ID_MENU_CONFER_CALL, MF_BYCOMMAND, MF_SEPARATOR );
					if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
					{
						pPopup->EnableMenuItem(ID_MENU_EXT_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
					}

					if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strCorpTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_05")))
					{
						pPopup->EnableMenuItem(ID_MENU_COMPANY_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
						
					}

					if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || strCellPhone.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_07")))
					{	
						pPopup->EnableMenuItem(ID_MENU_CELL_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
						
					}
					if(iptMyStatus != iptstACTIVE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
					{
						pPopup->EnableMenuItem(ID_MENU_CONFER_CALL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
						pPopup->EnableMenuItem(ID_MENU_FTRANSFER_CALL, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
					}
					
					if (!GET_CONFIG()->EnableFunction(_T("SR_08")))
					{
						pPopup->DeleteMenu(ID_MENU_CONFER_CALL, MF_BYCOMMAND);
						pPopup->DeleteMenu(ID_MENU_FTRANSFER_CALL, MF_BYCOMMAND);
						pPopup->DeleteMenu(ID_MENU_EXT_PHONE, MF_BYCOMMAND);
					}
					if (!GET_CONFIG()->EnableFunction(_T("SR_05")))
					{
						pPopup->DeleteMenu(ID_MENU_COMPANY_PHONE, MF_BYCOMMAND);
					}
					if (!GET_CONFIG()->EnableFunction(_T("SR_07")))
					{
						pPopup->DeleteMenu(ID_MENU_CELL_PHONE, MF_BYCOMMAND);
					}
				}
			}
		}
	}

	if (!HasAuth(AUTH_SHOW_IPT) && nSub == LIST_POPUP_MENU)
		pPopup->DeleteMenu(5, MF_BYPOSITION);
}

BOOL CWorkGroupDlg::IsAllIdsInBuddyGroup(CStringList& selectedIdList, int nGroupID)
{
	BOOL bAllUsersAreInTheBuddyGroup = TRUE;	// selectedIdList狼 葛电 荤侩磊啊 nGroupID 救俊 加秦 乐促搁 TRUE

	int buddyCount = g_pMessengerActor->GetBuddyCount(nGroupID);

	CStringList buddyIdInGroup;
	for (int index = 0; index < buddyCount; index++)
	{
		const IGTBuddyUser* pUser = g_pMessengerActor->GetBuddyInfoFromIndex(nGroupID, index);
		CString strBuddyID = pUser->GetUserID();
		buddyIdInGroup.AddTail(strBuddyID);
	}

	POSITION pos = selectedIdList.GetHeadPosition();

	while (pos)
	{
		CString strID = selectedIdList.GetNext(pos);

		if (buddyIdInGroup.Find(strID) == NULL)
		{
			bAllUsersAreInTheBuddyGroup = FALSE;
			break;
		}
	}

	return bAllUsersAreInTheBuddyGroup;
}

void CWorkGroupDlg::OnMnSendMemo()
{
	SendMemo();
}

void CWorkGroupDlg::OnMnTreeSendMemo()
{
	HTREEITEM hItem = m_pShownTree->GetSelectedItem();
	COrgTreeData *pTreeData = (COrgTreeData *)m_pShownTree->GetItemData(hItem);

	if (!pTreeData)
		return;

	NE_MEMBER_DATA_LIST DL;
	DL.nSize = 1;

	NE_MEMBER_DATA dlData;
	dlData.strName = pTreeData->GetName();
	CString strDL;

	if (GetViewType() == SHOW_ORG)
	{
		strDL.Format(_T("or_%s"), pTreeData->GetID());
	}
	else
	{
		strDL.Format(_T("wg_%s"), pTreeData->GetID());
	}

	dlData.strUserId = strDL;
	DL.pList = &dlData;

	m_pController->SendMemberListMemo(DL);
}

void CWorkGroupDlg::OnMnIMInvite()
{
	InviteIM();
}

void CWorkGroupDlg::OnMnTreeIMInvite()
{
	HTREEITEM hTree = m_pShownTree->GetSelectedItem();
	COrgTreeData *pTreeData = (COrgTreeData *)m_pShownTree->GetItemData(hTree);

	ASSERT(pTreeData);
}

void CWorkGroupDlg::OnMnProfile()
{
	int nSelectCount = m_pShownList->GetSelectedCount();

	if (nSelectCount < 0)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING218));
	}

	POSITION pos = m_pShownList->GetFirstSelectedItemPosition();


	CPoint pt(0, 0);
	GetCursorPos(&pt);
	//int nSelectedIndex = m_pShownList->GetNextSelectedItem(pos);
	CString strID = m_pShownList->GetItemText(m_nClickItem, m_nColUserID);
	CRect rcClient(0, 0, 0, 0);
	CRect rcSubItem(0, 0, 0, 0);
	::GetWindowRect(m_pShownList->GetSafeHwnd(), &rcClient);
	m_pShownList->GetSubItemRect(m_nClickItem, m_nClickSubItem, LVIR_LABEL, rcSubItem);
	RECT rcAround = {rcClient.left + rcSubItem.left, rcClient.top + rcSubItem.top, rcClient.left + rcSubItem.right, rcClient.top + rcSubItem.bottom};
	rcAround.left -= 20;
	//rcAround.right += 20;
	GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(strID, rcAround, m_pShownList->GetSafeHwnd());

}

void CWorkGroupDlg::OnMnCreateFavoriteGroup()
{
	if (g_pMessengerActor->GetBuddyGroupCount() >= MAX_GROUP)
	{	
		CString strMaxGroupCnt;
		strMaxGroupCnt.Format(IDS_STRING227, MAX_GROUP);
		NMessageBox(this, strMaxGroupCnt);
		
		return;
	}

	CCreateNewGroupWnd favCreateDlg(m_hWnd);
    GET_MESSENGER_DLG()->RegisterDuiModalWnd(&favCreateDlg);
	int nRet = favCreateDlg.ShowModal();
    GET_MESSENGER_DLG()->UnRegisterDuiModalWnd(&favCreateDlg);

	if (nRet == IDOK)
	{
		m_GroupList.clear();

		int nGroupID = favCreateDlg.GetCreatedGroupID();
		m_GroupList.insert(std::make_pair(WM_USER_ID_FAVORITE_BUTTON, nGroupID));

		if (m_ePopupMenuType == TREE_POPUP_MENU)
		{
			OnMenuTreeFavoriteAdd(WM_USER_ID_FAVORITE_BUTTON);
		}
		else 
		{
			OnMenuFavoriteButton(WM_USER_ID_FAVORITE_BUTTON);
		}
	}

	return;
}

void CWorkGroupDlg::OnMnChatHistory()
{
	int nSelectCount = m_pShownList->GetSelectedCount();

	if (nSelectCount < 0)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING218));
	}

	POSITION pos = m_pShownList->GetFirstSelectedItemPosition();

	int nSelectedIndex = m_pShownList->GetNextSelectedItem(pos);
	CString strID = m_pShownList->GetItemText(nSelectedIndex, m_nColUserID);
	GET_MESSENGER_DLG()->OpenChatHistoryDlg(strID);
}

void CWorkGroupDlg::OnMenuTreeFavoriteAdd(WPARAM wParam)
{
	int nID = (int)wParam;
	GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);

	int nGroupID = iter->second;
	TRACE(_T("OnMenuTreeFavoriteAdd GroupID = %d \n"),nGroupID);

	m_nAddFavoriteGroupID = nGroupID;

	HTREEITEM hItem = m_pShownTree->GetSelectedItem();
	COrgTreeData *pTreeData = (COrgTreeData *)m_pShownTree->GetItemData(hItem);

	if (pTreeData == NULL)
		return;

	if (GetViewType() == SHOW_ORG)
	{
		m_pController->AddORGGroupFavorites(pTreeData->GetParentID(), pTreeData->GetID(), nGroupID);
	}
	else
	{
		m_pController->AddWorkGroupFavorites(pTreeData->GetParentID(), pTreeData->GetID(), nGroupID);
	}
}

void CWorkGroupDlg::OnMenuFavoriteButton(WPARAM wParam)
{
	int nID = (int)wParam;
	GROUP_MEMU_LIST::iterator iter = m_GroupList.find(nID);
	int nGroupID = iter->second;

	POSITION pos = m_pShownList->GetFirstSelectedItemPosition();
	if (pos == NULL)
	{
		NMessageBox(this, LoadStringFromResource(IDS_STRING218));
		return;
	}

	std::vector<wstring> vecBuddyId;
	while(pos)
	{
		int nIndex = m_pShownList->GetNextSelectedItem(pos);
		CString strID = m_pShownList->GetItemText(nIndex, m_nColUserID);

		if (m_pController->IsMyID(strID))
			continue;

		vecBuddyId.push_back((LPCWSTR)strID);
	}

	if (vecBuddyId.empty() != true)
		m_pController->AddFavoriteList(vecBuddyId, nGroupID);
}

void CWorkGroupDlg::OnMenuIPT(WPARAM wParam)
{
	if (m_pShownList->GetSelectedCount() != 1)
		return;

	POSITION pos = m_pShownList->GetFirstSelectedItemPosition();
	int nIndex = m_pShownList->GetNextSelectedItem(pos);

	int nID = (int)wParam;
	CString strTelNo = _T("");

	switch (nID)
	{
	case ID_MENU_COMPANY_PHONE:
	case ID_MENU_IPT_CORP_PHONE:
		strTelNo = m_pShownList->GetItemText(nIndex, m_nColCorpTel);
		break;

	case ID_MENU_CELL_PHONE:
	case ID_MENU_IPT_CELLPHONE:
		strTelNo = m_pShownList->GetItemText(nIndex, m_nColCellPhone);
		break;

	case ID_MENU_EXT_PHONE:
	case ID_MENU_IPT_EXT_PHONE:
		strTelNo = m_pShownList->GetItemText(nIndex, m_nColExtensionTel);
		break;
	}

	NE_MEMBER_DATA userData;
	userData.strUserId = m_pShownList->GetItemText(nIndex, m_nColUserID);
	userData.strName = m_pShownList->GetItemText(nIndex, m_nColName);
	userData.strJobPos = m_pShownList->GetItemText(nIndex, m_nColJbps);
	userData.strJobDuty = m_pShownList->GetItemText(nIndex, m_nColJbdt);
	userData.strDept = m_pShownList->GetItemText(nIndex, m_nColDept);

	CallToIPT(userData, strTelNo);
}

void CWorkGroupDlg::SendMemo()
{
	int nSelectCount = m_pShownList->GetSelectedCount();

	if (nSelectCount > 0)
	{
		std::vector<ReceiverInfo> receiverVector;
		ReceiverInfo receiverInfo;
		POSITION pos = m_pShownList->GetFirstSelectedItemPosition();
		
		while (pos)
		{
			int nSelectedIndex = m_pShownList->GetNextSelectedItem(pos);
			receiverInfo.strID = m_pShownList->GetItemText(nSelectedIndex, m_nColUserID);
			receiverInfo.strName = m_pShownList->GetItemText(nSelectedIndex, m_nColName); 
			receiverVector.push_back(receiverInfo);
		}

		GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
	}
}

void CWorkGroupDlg::InviteIM()
{
	int nSelectCount = m_pShownList->GetSelectedCount();

	if (nSelectCount > 0)
	{
		POSITION pos = m_pShownList->GetFirstSelectedItemPosition();
		
		std::vector<NE_MEMBER_DATA> memberVector;
		while (pos)
		{
			int nSelectedIndex = m_pShownList->GetNextSelectedItem(pos);

			int nImage = m_pShownList->GetItemImage(nSelectedIndex, 0);
			if ((GTUserStatusType)nImage != ustOFFLINE)
			{
				int nIndex = m_pShownList->GetItemData(nSelectedIndex);
				if (nIndex >= 0)
				{
					const NE_MEMBER_DATA data = m_pModel->GetMember(nIndex);
					memberVector.push_back(data);
				}
			}
		}

		GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);
	}
}

void CWorkGroupDlg::OnDestroy()
{
	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ORGCHARTDLG);

	// Tree俊 且寸等 ItemData狼 皋葛府甫 秦力茄促.
	FreeTreeItemData(&m_treeOrg, m_treeOrg.GetRootItem());
	FreeTreeItemData(&m_treeWorkGroup, m_treeWorkGroup.GetRootItem());

	if (m_wndSearch.GetSafeHwnd())
		m_wndSearch.DestroyWindow();

	if(m_pWGButtons)
	{
		::DestroyWindow(m_pWGButtons->GetHWND());
		SAFE_DELETE(m_pWGButtons);
	}
	
	
	__super::OnDestroy();
}

void CWorkGroupDlg::OnLvnBeginrdragList(NMHDR *pNMHDR, LRESULT *pResult)
{
	BeginDrag();
}

void CWorkGroupDlg::OnLvnBegindragList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	BeginDrag();

	*pResult = 0;

}

void CWorkGroupDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	Invalidate(FALSE);
	RedrawWindow();
	__super::OnLButtonUp(nFlags, point);
}

void CWorkGroupDlg::OnNcLButtonUp(UINT nHitTest, CPoint point)
{
	Invalidate(FALSE);
	RedrawWindow();
	__super::OnNcLButtonUp(nHitTest, point);
}

void CWorkGroupDlg::ReSizeCtrl(void)
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);	

	// Search Window
	if (m_wndSearch.GetSafeHwnd() && m_comboLevel.GetSafeHwnd())
	{
		int nImgWidth = m_wndSearch.GetImgBGWidth();
		int nImgHeight = m_wndSearch.GetImgBGHeight();

		CRect rtSearch(0, 0, 0, 0);
		rtSearch.top = rcClient.top + 7;
		rtSearch.bottom = rtSearch.top + nImgHeight;
		rtSearch.right = rcClient.right - 11;
		rtSearch.left = rtSearch.right - 261;

		m_wndSearch.MoveWindow(&rtSearch);

		// Level search combobox
		m_comboLevel.MoveWindow(CRect(rtSearch.left - 122, rtSearch.top + 2 , rtSearch.left - 6, rtSearch.top + 22), TRUE);
	}

	if (HasAuth(AUTH_SHOW_ORG_TREE) || HasAuth(AUTH_SHOW_ORG_TREE))
	{

		// List
		if (m_lcOrg.GetSafeHwnd() && m_lcWork.GetSafeHwnd())
		{
			int nWidth = rcClient.right - m_rtSplitter.right - 11;
			if(MIN_LIST_WIDTH > nWidth && !IsIconic() && !IsZoomed())
			{
				m_rtSplitter.OffsetRect(nWidth - MIN_LIST_WIDTH, 0);
			}

			nWidth = rcClient.right - m_rtSplitter.right - 11;

			m_lcOrg.MoveWindow(m_rtSplitter.right, POINT_LIST_Y, nWidth, rcClient.bottom - POINT_LIST_Y - BTN_HEIGHT - 13, TRUE);
			m_lcWork.MoveWindow(m_rtSplitter.right, POINT_LIST_Y, nWidth, rcClient.bottom - POINT_LIST_Y - BTN_HEIGHT - 13, TRUE);

			CRect rcTreeList(rcClient);
			rcTreeList.top = POINT_TREE_Y;
			rcTreeList.bottom = rcClient.bottom - 49;
		}

		// Tree
		if (m_treeOrg.GetSafeHwnd() && m_treeWorkGroup.GetSafeHwnd())
		{
			m_treeOrg.MoveWindow(POINT_TREE_X, POINT_TREE_Y, m_rtSplitter.left, rcClient.bottom - BTN_HEIGHT - POINT_TREE_Y, TRUE);
			m_treeWorkGroup.MoveWindow(POINT_TREE_X, POINT_TREE_Y, m_rtSplitter.left, rcClient.bottom - BTN_HEIGHT - POINT_TREE_Y, TRUE);
		}

		m_rtSplitter.bottom = rcClient.bottom - BTN_HEIGHT - 14;
	}
	else	// 炼流档 鼻茄捞 绝绰 版快绰 府胶飘父 焊咯霖促.
	{
		if (m_lcOrg.GetSafeHwnd() && m_lcWork.GetSafeHwnd())
		{
			m_lcOrg.MoveWindow(11, POINT_LIST_Y, rcClient.right - 11 - 11, rcClient.bottom - POINT_LIST_Y - BTN_HEIGHT - 13, TRUE);
			m_lcWork.MoveWindow(11, POINT_LIST_Y, rcClient.right - 11 - 11, rcClient.bottom - POINT_LIST_Y - BTN_HEIGHT - 13, TRUE);
		}

		m_rtSplitter.bottom = 0;
	}

	// 滚瓢 困摹
	if(m_pWGButtons && m_pWGButtons->GetHWND())
	{
		CRect rcButtons(rcClient.left, rcClient.bottom+7 - BTN_HEIGHT, rcClient.right, rcClient.bottom + 7);
		m_pWGButtons->SetClientRect(rcButtons);
	}
	/*if (m_btnFavoriteAdd.GetSafeHwnd() && m_btnIMInvite.GetSafeHwnd() && m_btnRecipientAdd.GetSafeHwnd())
	{
		CRect rcBtn(0, 0, 0, 0);
		rcBtn.left = (rcClient.Width() / 2) - (BTN_WIDTH / 2) - BTN_GAP_X - BTN_WIDTH;
		rcBtn.right = rcBtn.left + BTN_WIDTH;
		rcBtn.bottom = rcClient.bottom - 7;
		rcBtn.top = rcBtn.bottom - BTN_HEIGHT;

		m_btnFavoriteAdd.MoveWindow(rcBtn, TRUE);
		m_btnFavoriteAdd.Invalidate();

		rcBtn.OffsetRect(BTN_WIDTH + BTN_GAP_X, 0);
		m_btnIMInvite.MoveWindow(rcBtn, TRUE);
		m_btnIMInvite.Invalidate();

		rcBtn.OffsetRect(BTN_WIDTH + BTN_GAP_X, 0);
		m_btnRecipientAdd.MoveWindow(rcBtn, TRUE);
		m_btnRecipientAdd.Invalidate();
	}*/

	// 八祸搬苞俊父 唱坷绰 牧飘费甸
	if (m_comboPage.GetSafeHwnd())
	{
		m_comboPage.MoveWindow(CRect(rcClient.right - POINT_PAGE_COMBO_X, POINT_PAGE_COMBO_Y, rcClient.right - POINT_PAGE_COMBO_X + 60, POINT_PAGE_COMBO_Y + 19), TRUE);
	}

	if (m_btnPrev.GetSafeHwnd() && m_btnNext.GetSafeHwnd())
	{
		m_btnNext.MoveWindow(CRect(rcClient.right - POINT_BTN_NEXT_X, POINT_BTN_PREV_Y, rcClient.right - POINT_BTN_NEXT_X + m_btnNext.GetImgWidth(), POINT_BTN_PREV_Y + m_btnNext.GetImgHeight()), TRUE);
		m_btnPrev.MoveWindow(CRect(rcClient.right - POINT_BTN_PREV_X, POINT_BTN_PREV_Y, rcClient.right - POINT_BTN_PREV_X + m_btnPrev.GetImgWidth(), POINT_BTN_PREV_Y + m_btnPrev.GetImgHeight()), TRUE);
	}
}

void CWorkGroupDlg::MoveSplitter()
{
	CRect rcClient(0, 0, 0, 0);
	GetClientRect(&rcClient);	

	// Tree
	if (m_treeOrg.GetSafeHwnd() && m_treeWorkGroup.GetSafeHwnd())
	{
		m_treeOrg.MoveWindow(POINT_TREE_X, POINT_TREE_Y, m_rtSplitter.left, rcClient.bottom - BTN_HEIGHT - POINT_TREE_Y - 17, TRUE);
		m_treeWorkGroup.MoveWindow(POINT_TREE_X, POINT_TREE_Y, m_rtSplitter.left, rcClient.bottom - BTN_HEIGHT - POINT_TREE_Y - 17, TRUE);
	}

	// List
	if (m_lcOrg.GetSafeHwnd() && m_lcWork.GetSafeHwnd())
	{
		m_lcOrg.MoveWindow(m_rtSplitter.right, POINT_LIST_Y, rcClient.right - m_rtSplitter.right - 11, rcClient.bottom - POINT_LIST_Y - 48 - 14, TRUE);
		m_lcWork.MoveWindow(m_rtSplitter.right, POINT_LIST_Y, rcClient.right - m_rtSplitter.right - 11, rcClient.bottom - POINT_LIST_Y - 48 - 14, TRUE);
	}

	// 傈眉 拳搁阑 Redraw且 版快 濒冠烙捞 乐栏骨肺 弥措茄 Redraw 康开阑 累霸 茄促.
	CRect rcTreeList(rcClient);
	rcTreeList.top = POINT_TREE_Y;
	rcTreeList.bottom = rcClient.bottom - 49;

	RedrawWindow(&rcTreeList);
}

void CWorkGroupDlg::OnSize(UINT nType, int cx, int cy)
{
	__super::OnSize(nType, cx, cy);

	ReSizeCtrl();
	RedrawWindow();
}

void CWorkGroupDlg::__ResourceLoad(BOOL bInit)
{

	if (bInit)
	{
		m_btnPrev.SetBtnBitmapFile(GetAppImgFile(_T("btn_navi_05.bmp")),RGB(0,0,0));
		m_btnPrev.SetToolTipText(LoadStringFromResource(IDS_STRING485));
		m_btnPrev.EnableHandCursor(TRUE);
		m_btnNext.SetBtnBitmapFile(GetAppImgFile(_T("btn_navi_06.bmp")),RGB(0,0,0));
		m_btnNext.SetToolTipText(LoadStringFromResource(IDS_STRING486));
		m_btnNext.EnableHandCursor(TRUE);
	}


	m_btnORGView.SetButtonText(LoadStringFromResource(IDS_STRING263));			// 炼流档
	m_btnWorkGroupView.SetButtonText(LoadStringFromResource(IDS_STRING264));
	m_btnORGView.EnableHandCursor(TRUE);
	m_btnWorkGroupView.EnableHandCursor(TRUE);
	if (bInit == FALSE)
	{
		FreeTreeItemData(&m_treeOrg, m_treeOrg.GetRootItem());
		m_treeOrg.DeleteAllItems();

		FreeTreeItemData(&m_treeWorkGroup, m_treeWorkGroup.GetRootItem());
		m_treeWorkGroup.DeleteAllItems();

		ShowCmd(m_eViewType);
		SendMessage(WM_SIZE, NULL, NULL);
	}

	SetLeftTopPNG(GetAppImgFile(_T("img_title_l.png")));
	SetCenterTopPNG(GetAppImgFile(_T("img_title_c.png")));
	SetRightTopPNG(GetAppImgFile(_T("img_title_r.png")));

	SetLeftBorderBitmap(GetAppImgFile(_T("new_02_left.bmp")));
	SetRightBorderBitmap(GetAppImgFile(_T("new_02_right.bmp")));

	SetLeftBottomPNG(GetAppImgFile(_T("img_bottom_l.png")));
	SetCenterBottomPNG(GetAppImgFile(_T("img_bottom_c.png")));
	SetRightBottomPNG(GetAppImgFile(_T("img_bottom_r.png")));
	SetUserBottomPNGBK(GetAppImgFile(_T("btn_popup_org_c_nor.png")));
	SetUserBottomPNG(GetAppImgFile(_T("btn_popup_org_bar.png")));

	SetExitBitmaps(GetAppImgFile(_T("btn_common_cancel_nor.bmp")),
		GetAppImgFile(_T("btn_common_cancel_foc.bmp")), GetAppImgFile(_T("btn_common_cancel_pre.bmp")));
	SetCloseEvent(TRUE);
}

CString CWorkGroupDlg::GetMemberName(CString strUserID)
{
	int nItemCount = m_pShownList->GetItemCount();
	for(int i = 0; i < nItemCount; i++)
	{
		CString strName = m_pShownList->GetItemText(i, m_nColUserID);
		if(strName.Compare(strUserID) == 0)
			return m_pShownList->GetItemText(i, m_nColName);
	}

	return CString(_T(""));
}

void CWorkGroupDlg::ChangeMyStatus(GTUserStatusType eMyStatus)
{
	int nItemCount = m_lcOrg.GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		CString strID = m_lcOrg.GetItemText(i, m_nColUserID);

		if (m_pController->IsMyID(strID))
		{
			m_pModel->UpdateMemberStatus(strID, eMyStatus);
			m_lcOrg.SetItemImage(i, m_nColStatus, m_pController->GetImageIndexFromStatus(eMyStatus));
			break;
		}
	}

	nItemCount = m_lcWork.GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		CString strID = m_lcWork.GetItemText(i, m_nColUserID);
		
		if (m_pController->IsMyID(strID))
		{
			m_pModel->UpdateMemberStatus(strID, eMyStatus);
			m_lcWork.SetItemImage(i, m_nColStatus, m_pController->GetImageIndexFromStatus(eMyStatus));
			break;
		}
	}
}

void CWorkGroupDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
{
	if (GetViewType() == SHOW_SEARCH)
	{
		lpMMI->ptMinTrackSize.x = SEARCH_DLG_MIN_X;
		lpMMI->ptMinTrackSize.y = SEARCH_DLG_MIN_Y;
	}
	else
	{
		lpMMI->ptMinTrackSize.x = ORG_DLG_MIN_X;
		lpMMI->ptMinTrackSize.y = ORG_DLG_MIN_Y;
	}

	__super::OnGetMinMaxInfo(lpMMI);
}

BOOL CWorkGroupDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int nID = LOWORD(wParam);

	switch (nID)
	{
	case ID_WORK_SEARCH:
		{
			m_searchParam.clear();
			m_bSortAscending = true;
			CString strSearchText = m_wndSearch.GetSearchText();
			DoSearch(strSearchText);
		}
		break;
	}

	return CSkinDialog::OnCommand(wParam, lParam);
}

GTUserStatusType CWorkGroupDlg::GetUserStatusFromImageIndex(int nIndex)
{
	GTUserStatusType status = (GTUserStatusType)nIndex;
	if( nIndex > ustMEETING )
		status = (GTUserStatusType)((nIndex - ustAUTOAWAY) | ustMOBILE);

	return status;
}

void CWorkGroupDlg::BeginDrag()
{
	const int nSelectCount = m_pShownList->GetSelectedCount();
	if (nSelectCount > 0)
	{
		CSharedFile file;
		CArchive ar(&file, CArchive::store);

		// 傈眉 急琶等 亲格 俺荐 历厘
		ar << nSelectCount;

		POSITION pos = m_pShownList->GetFirstSelectedItemPosition();
		while (pos)
		{
			int nSelectedIndex = m_pShownList->GetNextSelectedItem(pos);

			CNtalkDragData dropUser;
			dropUser.m_strID = m_pShownList->GetItemText(nSelectedIndex, m_nColUserID);
			dropUser.m_strName = m_pShownList->GetItemText(nSelectedIndex, m_nColName);
			dropUser.m_nUserStatus = GetUserStatusFromImageIndex(m_pShownList->GetItemImage(nSelectedIndex, m_nColStatus));
			dropUser.m_strExtensionTel = m_pShownList->GetItemText(nSelectedIndex, m_nColExtensionTel);
			dropUser.m_strCellphone = m_pShownList->GetItemText(nSelectedIndex, m_nColCellPhone);
			dropUser.m_strJobPos = m_pShownList->GetItemText(nSelectedIndex, m_nColJbps);
			dropUser.m_strJobDuty = m_pShownList->GetItemText(nSelectedIndex, m_nColJbdt);
			dropUser.m_strDeptName = m_pShownList->GetItemText(nSelectedIndex, m_nColDept);
			dropUser.m_hWndSrc = m_hWnd;
			dropUser.Serialize(ar);
		}

		ar.Close();

		_oleDataSource.CacheGlobalData(_clipBoardFormat, file.Detach()); 
		_oleDataSource.DoDragDrop();
	}
}

void CWorkGroupDlg::SetUserAuth()
{
	m_nUserAuth = AUTH_SHOW_NAME|AUTH_SHOW_DEPT|AUTH_SHOW_JBPS|AUTH_SHOW_JBDT;	// 扁夯鼻茄

	if (GET_CONFIG()->EnableFunction(_T("ME_02")) == TRUE)
		m_nUserAuth |= AUTH_SHOW_ORG_TREE;

	if (GET_CONFIG()->EnableFunction(_T("ME_03")) == TRUE)
		m_nUserAuth |= AUTH_SHOW_WORK_TREE;

	if (GET_CONFIG()->EnableFunction(_T("SC_12")) == TRUE)
	{
		m_nUserAuth |= AUTH_LEVEL_SEARCH;
		m_comboLevel.ShowWindow(SW_SHOW);

		InitLevels();
	}

	int nColSeq = m_nColJbdt + 1;	// 流氓 拿烦狼 牢郸胶何磐 窍唱究 棵扼埃促.

	if (GET_CONFIG()->EnableFunction(_T("ME_04")) == TRUE &&
		GET_APP()->IsAvailableIPT())
	{
		if (GET_CONFIG()->EnableFunction(_T("SR_05")) ||
			GET_CONFIG()->EnableFunction(_T("SR_07")) ||
			GET_CONFIG()->EnableFunction(_T("SR_08")))
		{
			m_nUserAuth |= AUTH_SHOW_IPT;
			m_nColIPTPresence = nColSeq++;
		}
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_08")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_EXT_TEL;
		m_nColExtensionTel = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_05")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_CORP_TEL;
		m_nColCorpTel = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_07")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_CELL_PH;
		m_nColCellPhone = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_06")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_FAX;
		m_nColFax = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_10")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_EMAIL;
		m_nColEmail = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_11")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_ROMNG_PH;
		m_nColRoamingTel = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_09")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_KEYWORD;
		m_nColKeyword = nColSeq++;
	}

	if (GET_CONFIG()->EnableFunction(_T("SR_12")) == TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_WORK_PL;
		m_nColPlace = nColSeq++;
	}
	if (GET_CONFIG()->EnableFunction(_T("UI_01"))==TRUE)
	{
		m_nUserAuth |= AUTH_SHOW_WORK_STATUS;
		m_nColWorkStatus = nColSeq++;
	}

	m_nColUserID = nColSeq++;
	m_nColJbpsCd = nColSeq++;
	m_nColJbdtCd = nColSeq++;
}

BOOL CWorkGroupDlg::HasAuth(DWORD nAuth)
{
	if ((m_nUserAuth & nAuth) == nAuth)
		return TRUE;

	return FALSE;
}

void CWorkGroupDlg::OnLvnItemchangedOrgList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	RefreshButtonStatus();

	*pResult = 0;
}

void CWorkGroupDlg::OnLvnItemchangedWorkgroupList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	RefreshButtonStatus();

	*pResult = 0;
}

void CWorkGroupDlg::RefreshButtonStatus()
{
	// 府胶飘俊 酒捞袍捞 绝芭唱 急琶等 亲格捞 绝绰 版快绰 葛滴 厚劝己拳(弊缝捞 厚绢乐澜阑 狼固)
	int nSelectedCount = m_pShownList->GetSelectedCount();

	if (m_pShownList->GetItemCount() == 0 || nSelectedCount == 0)
	{
		m_pWGButtons->SetButtonReadOnly(false, CWorkGroupButtons::All);
		return;
	}

	// 老窜 葛滴 劝己拳甫 矫难初绊 炼扒俊 蝶扼 厚劝己拳甫 魄窜茄促.
	m_pWGButtons->SetButtonReadOnly(true, CWorkGroupButtons::All);

	int nOnlineUserCount = m_pShownList->GetOnlineUserCount(false);

	if (IsSelectMyself())	// 郴 磊脚档 器窃登绢 急琶登绢 乐促搁 柯扼牢 荤侩磊 荐俊辑 1阑 哗霖促.
		nOnlineUserCount -= 1;

	// 唱 磊脚父 急琶等 版快
	if (nSelectedCount == 1 && IsSelectMyself())
	{
		m_pWGButtons->SetButtonReadOnly(false, CWorkGroupButtons::Add);
		m_pWGButtons->SetButtonReadOnly(false, CWorkGroupButtons::Chat);
		return;
	}
	else if (nOnlineUserCount <= 0)
	{
		m_pWGButtons->SetButtonReadOnly(false, CWorkGroupButtons::Chat);
	}

	// 急琶等 荤侩磊啊 榴败茫扁 弊缝俊 捞固 眠啊登菌绰瘤 酒囱瘤俊 蝶弗 '榴败茫扁'滚瓢 惑怕
	size_t nGroupCount = g_pMessengerActor->GetBuddyGroupCount();
	int nAddableBuddyGroupCount = 0;	// 模备眠啊啊 啊瓷茄 榴败茫扁 弊缝 俺荐
										// 弊缝 救俊 荤侩磊啊 殿废登绢 乐瘤 臼篮 版快父 季促.
	if (nGroupCount > 0)
	{
		CStringList selectedIdList;
		GetSelectedUserIDList(selectedIdList);	// 急琶等 荤侩磊ID 府胶飘

		// 榴败茫扁 弊缝
		for (size_t i = 0; i < nGroupCount; i++)
		{
			const IGTBuddyGroup *pGroup = g_pMessengerActor->GetBuddyGroupInfoFromIndex(i);

			int nGroupID = pGroup->GetID();

			// 傈眉 措惑 府胶飘甫 啊廉客辑
			// 茄疙捞扼档 殿废登瘤 臼篮 弊缝疙父 眠啊
			if (!IsAllIdsInBuddyGroup(selectedIdList, nGroupID))	// 急琶等 措惑磊 府胶飘 吝 榴败茫扁 弊缝 救俊 绝绰 荤恩捞 茄疙捞扼档 乐阑 版快
			{
				nAddableBuddyGroupCount++;
			}
		}
	}
	//Modify by sevin for bts:NTALKCL-1165
	//if (nGroupCount > 0 && nAddableBuddyGroupCount == 0)
	//	m_btnFavoriteAdd.EnableWindow(FALSE);

}

BOOL CWorkGroupDlg::OnGetItemToolTip(CNListCtrlEx* pThis, int iItem, int iSubItem, CString& strToolTip)
{
    if (pThis == m_pShownList)
    {
        if (0 == iSubItem)
        {
            CString strUserName = m_pShownList->GetItemText(iItem, m_nColName);
            CString strID = m_pShownList->GetItemText(iItem, m_nColUserID);
            GTUserStatusType status = m_pModel->GetMemberStatus(strID);

			WSTRING strWorkstatus = m_pModel->GetMemberWorkStatus(strID);
			if (ustOFFLINE == status 
				&& GET_CONFIG()->EnableFunction(_T("UI_01")) 
				&& !strWorkstatus.empty())
			{
				strToolTip = strWorkstatus.c_str();
				strToolTip.Replace(_T(":"),_T("\n"));
			}
			else
			{
				CString strStatus = GetPresenceTip(status);
				CString strMailAddr = m_pShownList->GetItemText(iItem, m_nColEmail);
				strToolTip.Format(TEXT("%s(%s)\r\n%s"), strUserName, strStatus, strMailAddr);
			}

            return TRUE;
        }
    }

    return FALSE;
}

void CWorkGroupDlg::ShowPageControls()
{
	if (m_bIsSearchResult)
	{
		for (int i = m_comboPage.GetCount() - 1; i >= 0; i--)
		{
			m_comboPage.DeleteString(i);
		}

		CString strPage;
		int nTotalPage = (m_pModel->GetSearchTotal() / PAGE_SIZE) + 1;
		for (int i = 0; i < nTotalPage; i++)
		{
			strPage.Format(_T("%d"), i + 1);
			m_comboPage.AddString(strPage);
		}

		int nCurrentPage = m_pModel->GetSearchPage();

		m_comboPage.SetCurSel(nCurrentPage - 1);

		if (nCurrentPage == 1)
			m_btnPrev.EnableWindow(FALSE);
		else
			m_btnPrev.EnableWindow(TRUE);

		if (nCurrentPage == nTotalPage)
			m_btnNext.EnableWindow(FALSE);
		else
			m_btnNext.EnableWindow(TRUE);

		m_comboPage.ShowWindow(SW_SHOW);
		m_btnPrev.ShowWindow(SW_SHOW);
		m_btnNext.ShowWindow(SW_SHOW);
	}
	else
	{
		m_strSortCol = _T("");
		m_comboPage.ShowWindow(SW_HIDE);
		m_btnPrev.ShowWindow(SW_HIDE);
		m_btnNext.ShowWindow(SW_HIDE);
	}

	CRect rcList(0, 0, 0, 0);
	m_lcOrg.GetWindowRect(&rcList);
	ScreenToClient(rcList);

	CRect rcDept = rcList;
	rcDept.top = POINT_TREE_Y + 1;
	rcDept.bottom = rcList.top - 1;
	RedrawWindow(&rcDept);
}

void CWorkGroupDlg::InitMemberList(bool bIsSearchResult)

{
	m_bIsSearchResult = bIsSearchResult;
	m_pShownList->ShowEmptyText(bIsSearchResult);
	ShowPageControls();

	// 捞傈俊 钎矫登绊 乐绰 荤侩磊狼 橇饭哩胶绰 罐瘤 臼酒档 登骨肺 殿废 秦力
	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_ORGCHARTDLG);
	m_pShownList->DeleteAllItems();

	bool bAllResultIsOneDept = true;	// 八祸搬苞狼 备己盔甸捞 葛滴 茄 何辑牢啊? (弊凡版快 飘府狼 秦寸 何辑甫 犬厘秦林绢具 茄促)
	CString strDeptId = _T("");			// 八祸搬苞狼 何辑ID甫 历厘

	const std::vector<ORG_MEMBER_DATA> memberVector = m_pModel->GetMemberVector();

	for (size_t i = 0; i < memberVector.size(); i++)
	{
		NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
		LVITEM lvItem;
		lvItem.mask = LVIF_IMAGE;
		lvItem.iItem = i;
		lvItem.iSubItem = 0;
		lvItem.iImage = memberVector[i].eStatus;

		m_pShownList->InsertItem(&lvItem);

		// 郴 惑怕酒捞能篮 流立 函版
		if (m_pController->IsMyID(sMemberInfo.strUserId.c_str()))
		{
			GTUserStatusType status = GET_MESSENGER_DLG()->GetMainFrame()->GetMyStatus();	// 葛官老 柯扼牢 惑怕绰 m_MainDlg.m_wndInfoAboutMe.m_gtStatus俊 馆康登绢 乐澜
			m_pModel->UpdateMemberStatus(sMemberInfo.strUserId.c_str(), status);
			m_pShownList->SetItemImage(i, m_nColStatus, m_pController->GetImageIndexFromStatus(status));
		}
		else
			if ( GET_CONFIG()->EnableFunction(_T("UI_01"))
				&& m_pModel->GetMemberStatus(sMemberInfo.strUserId.c_str()) == ustOFFLINE 
				&& !sMemberInfo.strWorkStatus.empty())
			{
				m_pShownList->SetItemImage(i, m_nColStatus, 14);
			}
			else
			{
				m_pShownList->SetItemImage(i, m_nColStatus, 0);
			}

		m_pShownList->SetItemText(i, m_nColName, sMemberInfo.strName.c_str());
		m_pShownList->SetItemText(i, m_nColDept, sMemberInfo.strDept.c_str());
		m_pShownList->SetItemText(i, m_nColJbps, sMemberInfo.strJobPos.c_str());
		m_pShownList->SetItemText(i, m_nColJbdt, sMemberInfo.strJobDuty.c_str());
		m_pShownList->SetItemText(i, m_nColExtensionTel, sMemberInfo.strExtesion.c_str());
		m_pShownList->SetItemText(i, m_nColCorpTel, sMemberInfo.strIncoTel.c_str());
		m_pShownList->SetItemText(i, m_nColCellPhone, sMemberInfo.strCellPhone.c_str());
		m_pShownList->SetItemText(i, m_nColFax, sMemberInfo.strFaxNum.c_str());
		m_pShownList->SetItemText(i, m_nColEmail, sMemberInfo.strEmail.c_str());
		m_pShownList->SetItemText(i, m_nColRoamingTel, sMemberInfo.strRmngPhone.c_str());
		m_pShownList->SetItemText(i, m_nColKeyword, sMemberInfo.strKeyword.c_str());
		m_pShownList->SetItemText(i, m_nColPlace, sMemberInfo.strWorkPlace.c_str());
		m_pShownList->SetItemText(i, m_nColUserID, sMemberInfo.strUserId.c_str());

		if (sMemberInfo.strJobPosCd == L"")
			m_pShownList->SetItemText(i, m_nColJbpsCd, sMemberInfo.strJobPos.c_str());
		else
			m_pShownList->SetItemText(i, m_nColJbpsCd, sMemberInfo.strJobPosCd.c_str());

		if (sMemberInfo.strJobDutyCd == L"")
			m_pShownList->SetItemText(i, m_nColJbdtCd, sMemberInfo.strJobDuty.c_str());
		else
			m_pShownList->SetItemText(i, m_nColJbdtCd, sMemberInfo.strJobDutyCd.c_str());

		if (HasAuth(AUTH_SHOW_IPT))
			m_pShownList->SetItemText(i, m_nColIPTPresence, _T("4"));	// iptstUNKNOWN

		if (HasAuth(AUTH_SHOW_WORK_STATUS))
		{
			m_pShownList->SetItemText(i,m_nColWorkStatus,sMemberInfo.strWorkStatus.c_str());//辟怕沥焊
		}
		m_pShownList->SetItemData(i, i);	// 沥纺阑 困秦 ItemData俊 Index甫 悸泼茄促. (瞒饶 促弗 蔼阑 荤侩且 版快 SortFunction阑 荐沥秦具 窃.)

		// 捞傈 流盔狼 何辑客 促福促搁 咯矾 何辑啊 八祸等 巴捞骨肺 飘府甫 犬厘且 荐 绝促.
		if (!strDeptId.IsEmpty() && strDeptId.CompareNoCase(sMemberInfo.strDeptId.c_str()) != 0)
			bAllResultIsOneDept = false;
		else
			strDeptId = sMemberInfo.strDeptId.c_str();
	}

	// 眠啊等 流盔甸狼 橇饭哩胶甫 罐扁 困秦 殿废
	vector<wstring> vecUsers;
	std::vector<ORG_MEMBER_DATA>::const_iterator itr = memberVector.begin();
	for(; itr != memberVector.end(); itr++)
		vecUsers.push_back(itr->neMemberData.strUserId);

	g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_ORGCHARTDLG);

	RefreshButtonStatus();

	// 八祸 搬苞捞绊, 何辑啊 窍唱老 版快 秦寸 搬苞狼 何辑甫 Expand 秦霖促.
	if (bIsSearchResult && bAllResultIsOneDept && !strDeptId.IsEmpty())
	{
		HTREEITEM hTreeItem = FindTreeItem(m_pShownTree, m_pShownTree->GetRootItem(), strDeptId);

		if (hTreeItem != NULL)
		{
			m_bSelectedBySearchResult = true;
			m_pShownTree->EnsureVisible(hTreeItem);
			m_pShownTree->SelectItem(hTreeItem);
		}
	}
}

void CWorkGroupDlg::MakeTreeChildNode(CTreeCtrl *pTree, HTREEITEM hParentItem, std::multimap<CString, CString> &parentChildMap, std::map<CString, CString> &groupNameMap)
{
	COrgTreeData *pParentTreeData = (COrgTreeData *)pTree->GetItemData(hParentItem);

	if (!pParentTreeData)
		return;

	// 泅犁 畴靛狼 磊侥甸阑 茫绰促.
	pair<std::multimap<CString, CString>::iterator, std::multimap<CString, CString>::iterator> iter_pair;
	iter_pair = parentChildMap.equal_range(pParentTreeData->GetID());

	CString strGroupID = _T("");
	CString strGroupName = _T("");

	std::multimap<CString, CString>::iterator iter;
	for (iter = iter_pair.first; iter != iter_pair.second; iter++)
	{
		// 茫篮 磊侥篮 Tree俊 Insert 茄促.
		strGroupID = iter->second;

		// 趣矫 何葛ID客 磊侥ID 啊 鞍篮 版快 公茄风橇俊 狐瘤霸 登聪 吧矾霖促.
		if (strGroupID.CompareNoCase(pParentTreeData->GetID()) == 0)
			continue;

		std::map<CString, CString>::iterator groupNameIter = groupNameMap.find(strGroupID);
		strGroupName = groupNameIter->second;
		HTREEITEM hItem = pTree->InsertItem(strGroupName, hParentItem, TVI_LAST);

		// Group 单捞磐甫 Tree狼 ItemData俊 官肺 甘俏矫挪促.
		COrgTreeData *pTreeData = new COrgTreeData(strGroupID, strGroupName, pParentTreeData->GetID());
		if (!pTreeData)
			continue;

		//Trace(_T("MakeTreeChildNode: %s, %s, %s\n"), pTreeData->GetParentID(), pTreeData->GetID(), pTreeData->GetName());
		pTree->SetItemData(hItem, (DWORD_PTR)pTreeData);
		MakeTreeChildNode(pTree, hItem, parentChildMap, groupNameMap);
	}
}

void CWorkGroupDlg::MakeTreeNodes(CTreeCtrl *pTree, const std::vector<GT_ORG_GROUP_DATA>& list)
{
	if (NULL == pTree)
		return;

	FreeTreeItemData(pTree, pTree->GetRootItem());
	pTree->DeleteAllItems();

	HTREEITEM hRootItem = NULL;
	std::multimap<CString, CString> parentChildMap;
	std::map<CString, CString> groupNameMap;

	for (size_t i = 0; i < list.size(); i++)
	{
		const GT_ORG_GROUP_DATA &sGroupInfo = list[i];

		// root 甫 茫酒 积己茄促. 
		// 曼绊肺 炼流档狼 root绰 Parent group ID 啊 绝绊, 诀公弊缝狼 root绰 Parent group ID == Group ID 捞促.
		if (sGroupInfo.strParentGroupID == _T("") || sGroupInfo.strGroupID == sGroupInfo.strParentGroupID)
		{
			hRootItem = pTree->InsertItem(sGroupInfo.strGroupName.c_str(), TVI_ROOT, TVI_LAST);

			// Group 单捞磐甫 Tree狼 ItemData俊 官肺 甘俏矫挪促.
			COrgTreeData *pTreeData = new COrgTreeData(sGroupInfo.strGroupID.c_str(), sGroupInfo.strGroupName.c_str(), sGroupInfo.strParentGroupID.c_str());
			if (NULL != pTreeData)
				pTree->SetItemData(hRootItem, (DWORD_PTR)pTreeData);

			continue;	// root绰 积己沁栏骨肺 map 俊 持瘤 臼绰促.
		}

		parentChildMap.insert(std::make_pair(sGroupInfo.strParentGroupID.c_str(), sGroupInfo.strGroupID.c_str()));
		groupNameMap.insert(std::make_pair(sGroupInfo.strGroupID.c_str(), sGroupInfo.strGroupName.c_str()));
	}

	// 磊侥畴靛甸阑 积己茄促.
	if (hRootItem)
		MakeTreeChildNode(pTree, hRootItem, parentChildMap, groupNameMap);

	if (pTree->GetCount() > 0)
	{
		pTree->Expand(hRootItem, TVE_EXPAND);
		pTree->UpdateWindow();	// 捞 临捞 绝阑 版快 Tree 备己 肯丰 饶 UI俊 诀单捞飘啊 登瘤 臼绰 版快啊 惯积
		RefreshButtonStatus();
	}
}

void CWorkGroupDlg::InitOrgGroupTree()
{
	MakeTreeNodes(&m_treeOrg, m_pModel->GetOrgGroupVector());
}

void CWorkGroupDlg::InitWorkGroupTree()
{
	MakeTreeNodes(&m_treeWorkGroup, m_pModel->GetWorkGroupVector());
}

void CWorkGroupDlg::UpdateMemberStatus(LPCWSTR strUserId)
{
	int nItemCount = m_pShownList->GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		CString strID = m_pShownList->GetItemText(i, m_nColUserID);

		if (strID.Compare(strUserId) == 0)
		{
			const std::vector<ORG_MEMBER_DATA> memberVector = m_pModel->GetMemberVector();
			NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
			const NE_MEMBER_DATA *member = g_pMessengerActor->GetEmployeeInfo(strUserId);
			if ( GET_CONFIG()->EnableFunction(_T("UI_01")) 
				&& m_pModel->GetMemberStatus(strUserId) == ustOFFLINE 
				&& !sMemberInfo.strWorkStatus.empty())
			{
				m_pShownList->SetItemImage(i, m_nColStatus, 14);
			}
			else
			{
				m_pShownList->SetItemImage(i, m_nColStatus, m_pController->GetImageIndexFromStatus(m_pModel->GetMemberStatus(strUserId)));
			}
		}
	}
}

void CWorkGroupDlg::UpdateMemberIPTStatus(LPCWSTR strUserId)
{
	int nItemCount = m_pShownList->GetItemCount();

	for (int i = 0; i < nItemCount; i++)
	{
		CString strID = m_pShownList->GetItemText(i, m_nColUserID);

		if (strID.Compare(strUserId) == 0)
		{
			CString strIPT;
			strIPT.Format(_T("%d"), m_pModel->GetMemberIPTStatus(strUserId));
			
			m_pShownList->SetItemText(i, m_nColIPTPresence, strIPT);
		}
	}
}

void CWorkGroupDlg::SetReadOnly( BOOL bStatus )
{
	BOOL bValue = !bStatus;
	m_treeOrg.EnableWindow(bValue);
	m_treeWorkGroup.EnableWindow(bValue);

	// 府胶飘 牧飘费
	m_lcOrg.EnableWindow(bValue);
	m_lcWork.EnableWindow(bValue);

	m_btnORGView.EnableWindow(bValue);
	m_btnWorkGroupView.EnableWindow(bValue);

	m_pWGButtons->SetButtonReadOnly(bValue, CWorkGroupButtons::All);

	Invalidate();

}

// 郴 磊脚父 急琶登菌绰瘤 犬牢
BOOL CWorkGroupDlg::IsSelectMyself()
{
	POSITION pos = m_pShownList->GetFirstSelectedItemPosition();

	while (pos)
	{
		int nItem = m_pShownList->GetNextSelectedItem(pos);
		CString strID = m_pShownList->GetItemText(nItem, m_nColUserID);

		if (m_pController->IsMyID(strID))
			return TRUE;
	}

	return FALSE;
}

void CWorkGroupDlg::OnHdnItemclickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMHEADER phdr = reinterpret_cast<LPNMHEADER>(pNMHDR);

	// 八祸搬苞捞绊, 1其捞瘤 捞惑牢 版快父 辑滚俊辑 啊廉柯促.
	if (m_bIsSearchResult && m_pModel->GetSearchTotal() > PAGE_SIZE)
	{
		if (phdr->iItem == m_nColName)
			m_strSortCol = _T("emp_nm");		
		else if (phdr->iItem == m_nColDept)
			m_strSortCol = _T("dept_nm");		
		else if (phdr->iItem == m_nColJbps)
			m_strSortCol = _T("jbps");		
		else if (phdr->iItem == m_nColJbdt)
			m_strSortCol = _T("jbdt");		
		else if (phdr->iItem == m_nColExtensionTel)
			m_strSortCol = _T("inco_tel_no");	
		else if (phdr->iItem == m_nColCorpTel)
			m_strSortCol = _T("tel_no");		
		else if (phdr->iItem == m_nColCellPhone)
			m_strSortCol = _T("cph_no");		
		else if (phdr->iItem == m_nColFax)
			m_strSortCol = _T("fax_no");		
		else if (phdr->iItem == m_nColEmail)
			m_strSortCol = _T("email_addr");	
		else if (phdr->iItem == m_nColRoamingTel)
			m_strSortCol = _T("rmngph_no");	
		else if (phdr->iItem == m_nColKeyword)
			m_strSortCol = _T("kwd_nm");		
		else if (phdr->iItem == m_nColPlace)
			m_strSortCol = _T("workpl_nm");	
		else if (phdr->iItem == m_nColWorkStatus)
			m_strSortCol = _T("work_status");	

		if (!m_strSearchText.IsEmpty())
		{
			m_bSortAscending = !m_bSortAscending;
			m_searchParam.clear();
			m_searchParam.strSortCol = m_strSortCol;
			m_bSortAscending ? m_searchParam.strSortAsc = L"asc" : m_searchParam.strSortAsc = L"desc";

			DoSearch(m_strSearchText);
		}
	}
	else
	{
		SORTPARAM sortParam;

		sortParam.pList = m_pShownList;
		sortParam.bSortAscending = m_bSortAscending;

		// 流困客 流氓篮 疙莫栏肺 沥纺窍瘤 臼绊 内靛肺 沥纺秦具 棵官弗 搬苞啊 唱柯促.
		if (phdr->iItem == m_nColJbps)
			sortParam.nSortColumn = m_nColJbpsCd;
		else if (phdr->iItem == m_nColJbdt)
			sortParam.nSortColumn = m_nColJbdtCd;
		else
			sortParam.nSortColumn = phdr->iItem;

		m_pShownList->SortItems(SortFunc, (LPARAM)&sortParam);
		m_bSortAscending = !m_bSortAscending;
	}

	*pResult = 0;
}

// List 沥纺阑 困茄 窃荐
int CALLBACK CWorkGroupDlg::SortFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	SORTPARAM *pSortParam = (SORTPARAM *)lParamSort;
	CNListCtrl *pList = pSortParam->pList;
	int nSortColumn = pSortParam->nSortColumn;
	bool bSortAscending = pSortParam->bSortAscending;

	LVFINDINFO info1, info2;
	info1.flags = LVFI_PARAM;
	info1.lParam = lParam1;
	info2.flags = LVFI_PARAM;
	info2.lParam = lParam2;
	int nRow1 = pList->FindItem(&info1, -1);
	int nRow2 = pList->FindItem(&info2, -1);

	CString strItem1 = pList->GetItemText(nRow1, nSortColumn);
	CString strItem2 = pList->GetItemText(nRow2, nSortColumn);

	return bSortAscending ? strItem1.CompareNoCase(strItem2) : -strItem1.CompareNoCase(strItem2);
}

bool CWorkGroupDlg::IsCloseMsg(MSG* pMsg)
{
	bool result = false;

	if (pMsg->hwnd != this->GetSafeHwnd())
		return false;

	if (pMsg->message == WM_CLOSE ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4) ||									// ALT + F4
		(pMsg->message == WM_SYSCOMMAND && (pMsg->wParam & 0xFFF0) == SC_CLOSE) ||						// 鸥捞撇官 快努腐皋春 > 摧扁
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))	// Close button
	{
		result = true;
	}

	return result;
}

bool CWorkGroupDlg::IsIPPhoneLinkColumn(int nCol)
{
	if (HasAuth(AUTH_SHOW_IPT))
	{
		if (nCol == m_nColIPTPresence)
			return true;
	}

	return false;
}
bool CWorkGroupDlg::IsWorkStatusColumn(int nCol)
{
	if (HasAuth(AUTH_SHOW_WORK_STATUS))
	{
		if (nCol == m_nColWorkStatus)
			return true;
	}

	return false;
}


void CWorkGroupDlg::OnNMClickList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	if (pNMItemActivate->iSubItem == 0 && GET_CONFIG()->EnableFunction(_T("UI_03")))
	{
		m_nClickItem = pNMItemActivate->iItem;
		m_nClickSubItem = pNMItemActivate->iSubItem;
		OnMnProfile();  
		return;
	}

	if (IsIPPhoneLinkColumn(pNMItemActivate->iSubItem))
	{
		CPoint pt(0, 0);
		GetCursorPos(&pt);

		CString strUserID = m_pShownList->GetItemText(pNMItemActivate->iItem, m_nColUserID);

		if (m_pController->IsMyID(strUserID))
			return;

		NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
		NTIPTStatusType iptStatusOfBuddy = m_pModel->GetMemberIPTStatus(strUserID);

		if( iptStatusOfBuddy == iptstNA || iptStatusOfBuddy == iptstEXT01 || iptStatusOfBuddy == iptstEXT02 )
			return;

		CString strCorpTel = m_pShownList->GetItemText(pNMItemActivate->iItem, m_nColCorpTel);
		CString strCellPhone = m_pShownList->GetItemText(pNMItemActivate->iItem, m_nColCellPhone);
		CString strExtensionTel = m_pShownList->GetItemText(pNMItemActivate->iItem, m_nColExtensionTel);

		CMenu menuList;
		menuList.LoadMenu(IDR_MEMU_COMMON_MENU);
		menuList.InsertMenu(ID_MENU_IPT_CONFER, MF_BYCOMMAND, MF_SEPARATOR );
		if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
		{
			menuList.EnableMenuItem(ID_MENU_IPT_EXT_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}

		if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || iptStatusOfBuddy != iptstIDLE || strCorpTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_05")))
		{
			menuList.EnableMenuItem(ID_MENU_IPT_CORP_PHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}

		if (!(iptMyStatus == iptstIDLE || iptMyStatus == iptstDND || iptMyStatus == iptstFWD) || strCellPhone.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_07")))
		{	
			menuList.EnableMenuItem(ID_MENU_IPT_CELLPHONE, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}
		if(iptMyStatus != iptstACTIVE || strExtensionTel.IsEmpty() || !GET_CONFIG()->EnableFunction(_T("SR_08")))
		{
			menuList.EnableMenuItem(ID_MENU_IPT_CONFER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
			menuList.EnableMenuItem(ID_MENU_IPT_TRANSFER, MF_BYCOMMAND | MF_DISABLED | MF_GRAYED);
		}

		if (!GET_CONFIG()->EnableFunction(_T("SR_08")))
		{
			menuList.DeleteMenu(ID_MENU_IPT_CONFER, MF_BYCOMMAND);
			menuList.DeleteMenu(ID_MENU_IPT_TRANSFER, MF_BYCOMMAND);
			menuList.DeleteMenu(ID_MENU_IPT_EXT_PHONE, MF_BYCOMMAND);
		}
		if (!GET_CONFIG()->EnableFunction(_T("SR_05")))
		{
			menuList.DeleteMenu(ID_MENU_IPT_CORP_PHONE, MF_BYCOMMAND);
		}
		if (!GET_CONFIG()->EnableFunction(_T("SR_07")))
		{
			menuList.DeleteMenu(ID_MENU_IPT_CELLPHONE, MF_BYCOMMAND);
		}

		menuList.GetSubMenu(7)->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);
	}

	*pResult = 0;
}

void CWorkGroupDlg::CallToIPT(NE_MEMBER_DATA userData, CString strTel)
{
	if (strTel.IsEmpty())
		return;

	CDialPadManager* pManager = CDialPadManager::GetDialpadManager();

	if (pManager)
		pManager->MakeCall(userData, strTel);
}

void CWorkGroupDlg::OnMenuSms()
{
	int nSelectCount = m_pShownList->GetSelectedCount();

	if (nSelectCount > 0)
	{
		std::vector<CSMSModel::SMSReceiverInfo> receiverVector;
		CSMSModel::SMSReceiverInfo receiverInfo;
		POSITION pos = m_pShownList->GetFirstSelectedItemPosition();

		while (pos)
		{
			int nSelectedIndex = m_pShownList->GetNextSelectedItem(pos);
			receiverInfo.strID = m_pShownList->GetItemText(nSelectedIndex, m_nColUserID);
			receiverInfo.strName = m_pShownList->GetItemText(nSelectedIndex, m_nColName);
			receiverInfo.strCellPhone = m_pShownList->GetItemText(nSelectedIndex,m_nColCellPhone);
			receiverVector.push_back(receiverInfo);
		}

		GET_APP()->m_pSMSDialogManager->CreateListSMS(receiverVector, this);
	}
}

void CWorkGroupDlg::OnMenuTreeSms()
{
	HTREEITEM hItem = m_pShownTree->GetSelectedItem();
	COrgTreeData *pTreeData = (COrgTreeData *)m_pShownTree->GetItemData(hItem);

	ASSERT(pTreeData);

	if (GetViewType() == SHOW_ORG)
	{
		m_pController->RequestORGGroupMemberListSMS(pTreeData->GetParentID(), pTreeData->GetID());
	}
	else
	{
		m_pController->RequestWorkGroupMemberListSMS(pTreeData->GetParentID(), pTreeData->GetID());
	}

}

void CWorkGroupDlg::InitTreeCtrl()
{
	// 炼流档 飘府
	m_treeOrg.EnableToolTips(FALSE);
	m_treeOrg.SetFont(&g_ftDefault8PT, TRUE);
	m_treeOrg.ModifyStyle(NULL , TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS);
	m_treeOrg.SendMessage(TVM_SETITEMHEIGHT, (WPARAM)20, 0);
	m_treeOrg.EnableToolTips(FALSE);
	m_treeOrg.EnableTrackingToolTips(FALSE);
	m_treeOrg.ShowWindow(SW_SHOW);

	// 诀公弊缝 飘府
	m_treeWorkGroup.EnableToolTips(FALSE);
	m_treeWorkGroup.SetFont(&g_ftDefault8PT, TRUE);
	m_treeWorkGroup.ModifyStyle(NULL , TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS);
	m_treeWorkGroup.SendMessage(TVM_SETITEMHEIGHT, (WPARAM)20, 0);
	m_treeWorkGroup.EnableToolTips(FALSE);
	m_treeWorkGroup.EnableTrackingToolTips(FALSE);
	m_treeWorkGroup.ShowWindow(SW_SHOW);
}

void CWorkGroupDlg::InitTab()
{
	// 惑窜 炼流档, 诀公弊缝 徘 滚瓢
	m_btnORGView.MoveWindow(0, 0, 101, 35, TRUE);
	m_btnWorkGroupView.MoveWindow(102, 0, 101, 35, TRUE);

	m_btnORGView.SetTabBitmapFile(GetAppImgFile(_T("tab_work.bmp")),RGB(0,0,0));
	m_btnORGView.SetFont(&g_ftDefault9PT);
	m_btnORGView.SetTextColor(RGB(78, 157, 199), RGB(34, 34, 34));
	m_btnORGView.ShowWindow(SW_SHOW);

	m_btnWorkGroupView.SetTabBitmapFile(GetAppImgFile(_T("tab_work.bmp")),RGB(0,0,0));
	m_btnWorkGroupView.SetFont(&g_ftDefault9PT);
	m_btnWorkGroupView.SetTextColor(RGB(78, 157, 199), RGB(34, 34, 34));
	m_btnWorkGroupView.ShowWindow(SW_SHOW);

	// 鼻茄捞 绝绰 荤侩磊绰 飘府甫 焊咯林瘤 臼绰促.
	//if (!(HasAuth(AUTH_SHOW_ORG_TREE) || HasAuth(AUTH_SHOW_ORG_TREE)))
	if (!HasAuth(AUTH_SHOW_ORG_TREE))
	{
		m_btnORGView.ShowWindow(SW_HIDE);
		m_btnORGView.MoveWindow(0, 0, 0, 0);
		m_btnWorkGroupView.ShowWindow(SW_HIDE);
		m_btnWorkGroupView.MoveWindow(0, 0, 0, 0);

		m_treeOrg.ShowWindow(SW_HIDE);
		m_treeWorkGroup.ShowWindow(SW_HIDE);

		SetViewType(SHOW_SEARCH);
	}
}

void CWorkGroupDlg::InitPageCtrls()
{
	m_comboPage.SetFont(&g_ftDefault12PX);
	m_comboPage.SetTextColor(COLOR_LC_NORMAL_TEXT);
	m_comboPage.ShowWindow(SW_HIDE);
	m_btnPrev.ShowWindow(SW_HIDE);
	m_btnNext.ShowWindow(SW_HIDE);
}

void CWorkGroupDlg::InitListCtrl()
{
	// 府胶飘俊 荤侩且 捞固瘤 府胶飘
	if (m_ilStatus.Create(24, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 14, 3))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 14;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetBuddyPresenceImageFilePath((GTUserStatusType)(i > ustMEETING ? i - (ustMEETING+1) | ustMOBILE : i));

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ilStatus.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}

		CString strImageFilePath = GET_APP()->GetWorkStatusImageFilePath();

		CBitmap bmStatus;
		LoadBitmapFromPath(bmStatus, strImageFilePath);
		m_ilStatus.Add(&bmStatus, crMask);
	}

	// 府胶飘俊 荤侩且 IPT 惑怕 捞固瘤 府胶飘
	if (m_ilIPTStatus.Create(18, 18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 12, 3))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 9;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetOrgIPTPresenceImageFilePath((NTIPTStatusType)i);

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ilIPTStatus.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}
	}
	if (m_ilWorkStatus.Create(24,18, ILC_COLOR32 | ILC_COLOR | ILC_MASK, 2, 2))
	{
		COLORREF crMask = RGB(0, 0, 0);

		const BYTE nStatusCnt = 2;
		for( BYTE i = 0; i < nStatusCnt; i++ )
		{
			CString strImageFilePath = GET_APP()->GetWorkStatusImageFilePath();

			CBitmap bmStatus;
			LoadBitmapFromPath(bmStatus, strImageFilePath);
			m_ilWorkStatus.Add(&bmStatus, crMask);
			bmStatus.DeleteObject();
		}
	}

	// 府胶飘 拿烦 Width
	int colWidthList[] = {
		30,		// 惑怕
		50,		// 捞抚
		110,	// 家加
		50,		// 流困
		50,		// 流氓
		30,		// IPT 橇饭哩胶
		90,		// 郴急锅龋
		90,		// 雀荤傈拳
		90,		// 绒措迄
		90,		// 蒲胶
		110,	// 捞皋老
		90,		// 肺怪迄
		90,		// 虐况靛
		60,		// 档矫
		0,		// 辟怕
		0,		// UserID(见辫)
		0,		// 流困内靛(见辫)
		0,		// 流氓内靛(见辫)
		-1
	};

	// 府胶飘 拿烦 庆歹 力格
	CStringArray arrListHeaderTitle;
	arrListHeaderTitle.Add(_T(""));									// 惑怕 酒捞能
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING142));	// 捞抚
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING143));	// 家加
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING268));	// 流困
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING269));	// 流氓
	arrListHeaderTitle.Add(_T("IPT"));								// IPT
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING270));	// 郴急锅龋
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING271));	// 雀荤傈拳
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING272));	// 绒措迄
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING273));	// 蒲胶锅龋
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING274));	// E-mail
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING275));	// 肺怪迄
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING276));	// 虐况靛
	arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING277));	// 档矫
	//arrListHeaderTitle.Add(LoadStringFromResource(IDS_STRING635));								// 辟怕
	arrListHeaderTitle.Add(_T(""));								// 辟怕
	arrListHeaderTitle.Add(_T(""));									// User ID
	arrListHeaderTitle.Add(_T(""));									// 流困内靛
	arrListHeaderTitle.Add(_T(""));									// 流氓内靛

	// 炼流档 府胶飘
	m_lcOrg.SetImageList(&m_ilStatus, LVSIL_SMALL);
	InitListColumn(m_lcOrg, arrListHeaderTitle, colWidthList);
	m_lcOrg.SetIPTPresenceImageList(&m_ilIPTStatus);
	m_lcOrg.SetIPTPresenceColumn(m_nColIPTPresence);
	m_lcOrg.SetWorkStatusImageList(&m_ilWorkStatus);
	m_lcOrg.SetWorkStatusColumn(m_nColWorkStatus);
    m_lcOrg.SetCallBack(this);
    m_lcOrg.SetEnableItemToolTips(TRUE);
	//m_lcOrg.SetTrackHoverFlag(true);
	m_lcOrg.SetImageColumn(m_nColStatus);

	// 诀公弊缝 府胶飘
	m_lcWork.SetImageList(&m_ilStatus, LVSIL_SMALL);
	InitListColumn(m_lcWork, arrListHeaderTitle, colWidthList);
	m_lcWork.SetIPTPresenceImageList(&m_ilIPTStatus);
	m_lcWork.SetIPTPresenceColumn(m_nColIPTPresence);
	m_lcWork.SetWorkStatusImageList(&m_ilWorkStatus);
	m_lcWork.SetWorkStatusColumn(m_nColWorkStatus);
    m_lcWork.SetCallBack(this);
    m_lcWork.SetEnableItemToolTips(TRUE);
	//m_lcWork.SetTrackHoverFlag(true);
	m_lcWork.SetImageColumn(m_nColStatus);

}

void CWorkGroupDlg::InitListColumn(CNListCtrl &list, CStringArray &strHeaderTitle, const int *arrWidth)
{
	// 拿烦 积己
	LV_COLUMN lvcolumn;
	memset(&lvcolumn, 0, sizeof(lvcolumn));
	lvcolumn.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_MINWIDTH | LVCF_WIDTH;

	int nAuth = AUTH_SHOW_NAME;
	int nColSeq = 0;

	// 拿烦 荤捞令 汲沥
	std::list<int> freezeColList;
	std::list<int> linkColList;

	for (int i = 0; i < strHeaderTitle.GetCount(); i++)
	{
		if (i == 0 || nAuth > AUTH_SHOW_WORK_STATUS)
		{
			lvcolumn.fmt = LVCFMT_LEFT;
			lvcolumn.pszText = (LPTSTR)(LPCTSTR)strHeaderTitle.GetAt(i);
			lvcolumn.iSubItem = i;
			lvcolumn.cxMin = 0;
			lvcolumn.cx = arrWidth[i];
			list.InsertColumn(i, &lvcolumn);

			if (arrWidth[i] == 0)
				freezeColList.push_back(nColSeq);

			if (IsIPPhoneLinkColumn(nColSeq))
				linkColList.push_back(nColSeq);
			if (IsWorkStatusColumn(nColSeq))
				linkColList.push_back(nColSeq);

			nColSeq++;
			continue;
		}
		else if (!HasAuth(nAuth))
		{
			nAuth = nAuth << 1;
			continue;
		}

		lvcolumn.fmt = LVCFMT_LEFT;
		lvcolumn.pszText = (LPTSTR)(LPCTSTR)strHeaderTitle.GetAt(i);
		lvcolumn.iSubItem = i;
		lvcolumn.cxMin = 0;
		lvcolumn.cx = arrWidth[i];
		list.InsertColumn(i, &lvcolumn);

		if (arrWidth[i] == 0)
			freezeColList.push_back(nColSeq);

		if (IsIPPhoneLinkColumn(nColSeq))
			linkColList.push_back(nColSeq);
		if (IsWorkStatusColumn(nColSeq))
			linkColList.push_back(nColSeq);


		nAuth = nAuth << 1;
		nColSeq++;
	}

	list.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_DOUBLEBUFFER);
	list.SetRowHeight(19);			// 府胶飘 酒捞袍 臭捞 汲沥
	list.SetTextFont(&g_ftDefault8PT);	// 府胶飘 迄飘 汲沥
	list.GetHeaderCtrl()->SetFont(&g_ftDefault8PT);

	list.SetFreezeColumns(freezeColList);		// Width啊 0牢 拿烦篮 Freesze 矫挪促
	//list.SetExternalLinkColumns(linkColList);	// IP phone栏肺 楷搬且 拿烦(傈拳锅龋)

	list.SetMinColumnWidth(20);
	list.RedrawWindow();
}

BOOL CWorkGroupDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
{

	switch (m_nCursor)
	{
	case CURSOR_HSPLITTER:
		::SetCursor(AfxGetApp()->LoadCursor(AFX_IDC_HSPLITBAR));
		return TRUE;
	}

	return __super::OnSetCursor(pWnd, nHitTest, message);
}

void CWorkGroupDlg::OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	BeginWaitCursor();

	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);
	int nItem = pNMItemActivate->iItem;

	CString strUserID = m_pShownList->GetItemText(nItem, m_nColUserID);

	if (strUserID.IsEmpty())
		return;

	int nImage = m_pShownList->GetItemImage(nItem, m_nColStatus);

	if ((GTUserStatusType)nImage != ustOFFLINE)	// 盲泼
	{
		if (m_pController->IsMyID(strUserID))
			return;

		std::vector<NE_MEMBER_DATA> memberVector;
		int nIndex = m_pShownList->GetItemData(nItem);
		
		if (nIndex >= 0)
		{
			const NE_MEMBER_DATA data = m_pModel->GetMember(nIndex);
			memberVector.push_back(data);
			GET_APP()->m_pChatDialogManager->CreateMemberChat(memberVector);
		}
	}
	else	// 率瘤
	{
		std::vector<ReceiverInfo> receiverVector;
		ReceiverInfo receiverInfo;
		POSITION pos = m_pShownList->GetFirstSelectedItemPosition();

		receiverInfo.strID = m_pShownList->GetItemText(nItem, m_nColUserID);
		receiverInfo.strName = m_pShownList->GetItemText(nItem, m_nColName); 
		receiverVector.push_back(receiverInfo);

		GET_APP()->m_pSendNoteManager->CreateReceiverInfoListNote(receiverVector);
	}

	*pResult = 0;
}

void CWorkGroupDlg::MouseMove(MSG* pMsg, CRect &rcWnd)
{
	CPoint ptCursor(pMsg->pt);
	ScreenToClient(&ptCursor);


	if (m_rtSplitter.PtInRect(ptCursor))
		m_nCursor = CURSOR_HSPLITTER;
	else
		m_nCursor = CURSOR_DEFAULT;

	CRect rtList, rtHeader;
	m_pShownList->GetWindowRect(&rtList);
	ScreenToClient(&rtList);
	m_pShownList->GetHeaderCtrl()->GetWindowRect(&rtHeader);
	rtList.DeflateRect(0, rtHeader.Height(), 0, 0);

	// 府胶飘 康开狼 胶农费 呈厚 拌魂
	SCROLLBARINFO ScrollBarInfo;
	::ZeroMemory(&ScrollBarInfo, sizeof(ScrollBarInfo));
	ScrollBarInfo.cbSize = sizeof(ScrollBarInfo);

	if (m_pShownList->GetScrollBarInfo(OBJID_HSCROLL, &ScrollBarInfo))
	{
		if (!(ScrollBarInfo.rgstate[0] & STATE_SYSTEM_INVISIBLE))
			rtList.DeflateRect(0, 0, 0, GetSystemMetrics(SM_CYHSCROLL));
	}

	::ZeroMemory(&ScrollBarInfo, sizeof(ScrollBarInfo));
	ScrollBarInfo.cbSize = sizeof(ScrollBarInfo);

	if (m_pShownList->GetScrollBarInfo(OBJID_VSCROLL, &ScrollBarInfo))
	{
		if (!(ScrollBarInfo.rgstate[0] & STATE_SYSTEM_INVISIBLE))
			rtList.DeflateRect(0, 0, GetSystemMetrics(SM_CXVSCROLL), 0);
	}

	//Trace(_T("(%d,%d)(%d,%d,%d,%d)\n"), ptCursor.x, ptCursor.y, rtList.left, rtList.top, rtList.right, rtList.bottom);

	// 府胶飘 康开 观栏肺 目辑啊 唱艾阑 版快 寇何傅农狼 惑怕甫 盔惑汗备 矫挪促
	if (!rtList.PtInRect(ptCursor))
		m_pShownList->ResetHoverStatus();

	if (m_nHitTest == HTLEFT)
	{
		if ((rcWnd.Width() - ptCursor.x) > ORG_DLG_MIN_X)
			MoveWindow(rcWnd.left + ptCursor.x, rcWnd.top, rcWnd.Width() - ptCursor.x, rcWnd.Height(), TRUE);
	}
	else if (m_nHitTest == HTRIGHT)
	{
		MoveWindow(rcWnd.left, rcWnd.top, ptCursor.x + m_nBorderWidth, rcWnd.Height(), TRUE);
	}
	else if (m_nHitTest == HTTOP)
	{
		if (rcWnd.Height() - (ptCursor.y + m_nBorderHeight) > ORG_DLG_MIN_Y)
			MoveWindow(rcWnd.left, rcWnd.top + ptCursor.y + m_nBorderHeight, rcWnd.Width(), rcWnd.Height() - (ptCursor.y + m_nBorderHeight), TRUE);
	}
	else if (m_nHitTest == HTBOTTOM)
	{
		MoveWindow(rcWnd.left, rcWnd.top, rcWnd.Width(), ptCursor.y + m_nBorderHeight, TRUE);
	}
	else if (m_nHitTest == HTTOPLEFT)
	{
		CRect rcDlg(0, 0, 0, 0);
		rcDlg.SetRect(rcWnd.left + ptCursor.x, rcWnd.top + ptCursor.y + m_nBorderHeight, rcWnd.left + rcWnd.Width(), rcWnd.top + rcWnd.Height());

		if (rcDlg.Height() <= ORG_DLG_MIN_Y)
		{
			rcDlg.top = rcWnd.top;
			rcDlg.bottom = rcWnd.bottom;
		}

		if (rcDlg.Width() <= ORG_DLG_MIN_X)
		{
			rcDlg.left = rcWnd.left;
			rcDlg.right = rcWnd.right;
		}

		MoveWindow(rcDlg, TRUE);
	}
	else if (m_nHitTest == HTTOPRIGHT)
	{
		CRect rcDlg(0, 0, 0, 0);
		rcDlg.SetRect(rcWnd.left, rcWnd.top + ptCursor.y + m_nBorderHeight, rcWnd.left + ptCursor.x + m_nBorderWidth, rcWnd.top + rcWnd.Height());

		if (rcDlg.Height() <= ORG_DLG_MIN_Y)
		{
			rcDlg.top = rcWnd.top;
			rcDlg.bottom = rcWnd.bottom;
		}

		if (rcDlg.Width() <= ORG_DLG_MIN_X)
		{
			rcDlg.left = rcWnd.left;
			rcDlg.right = rcWnd.right;
		}

		MoveWindow(rcDlg, TRUE);
	}
	else if (m_nHitTest == HTBOTTOMLEFT)
	{
		CRect rcDlg(0, 0, 0, 0);
		rcDlg.SetRect(rcWnd.left + ptCursor.x, rcWnd.top, rcWnd.left + rcWnd.Width(), rcWnd.top + ptCursor.y + m_nBorderHeight);

		if (rcDlg.Height() <= ORG_DLG_MIN_Y)
		{
			rcDlg.top = rcWnd.top;
			rcDlg.bottom = rcWnd.bottom;
		}

		if (rcDlg.Width() <= ORG_DLG_MIN_X)
		{
			rcDlg.left = rcWnd.left;
			rcDlg.right = rcWnd.right;
		}

		MoveWindow(rcDlg, TRUE);
	}
	else if (m_nHitTest == HTBOTTOMRIGHT)
	{
		MoveWindow(rcWnd.left, rcWnd.top, ptCursor.x + m_nBorderWidth, ptCursor.y + m_nBorderHeight, TRUE);
	}
	else if (m_bSplitterClicked)	// 胶敲府磐甫 靛贰弊 窍绰 版快(飘府/府胶飘 农扁 炼例)
	{
		if (MIN_TREE_WIDTH < ptCursor.x && (rcWnd.Width() - ptCursor.x > MIN_LIST_WIDTH))
		{
			m_rtSplitter.left = ptCursor.x - 4;
			m_rtSplitter.right = ptCursor.x + 5;
			MoveSplitter();
		}
	}


	int nItem = -1;
	int nSubItem = -1;

	LVHITTESTINFO   lvinfo; 
	CPoint ptCursorInList(pMsg->pt);
	m_pShownList->ScreenToClient(&ptCursorInList);
	lvinfo.pt   =   ptCursorInList; 
	lvinfo.flags   =   LVHT_ABOVE; 
	if(m_pShownList->GetSafeHwnd() && (-1 != m_pShownList->SubItemHitTest(&lvinfo)))
	{
		if(IsIPPhoneLinkColumn(lvinfo.iSubItem))
		{
			CString strUserID = m_pShownList->GetItemText(lvinfo.iItem, m_nColUserID);

			if (m_pController->IsMyID(strUserID))
				return;

			NTIPTStatusType iptMyStatus = g_pMessengerActor->GetMyIptStatus();
			NTIPTStatusType iptStatusOfBuddy = m_pModel->GetMemberIPTStatus(strUserID);

			if( iptStatusOfBuddy == iptstNA || iptStatusOfBuddy == iptstEXT01 || iptStatusOfBuddy == iptstEXT02 )
				return;

			::SetCursor(::LoadCursor(NULL, MAKEINTRESOURCE(IDC_HAND)));
		}

	}

}

void CWorkGroupDlg::OnCbnSelchangeComboPage()
{
	int nSel = m_comboPage.GetCurSel();

	if (nSel != CB_ERR)
	{
		if (m_pModel->GetSearchPage() == nSel + 1)
			return;

		if (!m_strSearchText.IsEmpty())
		{
			m_searchParam.clear();
			m_searchParam.nPage = nSel + 1;
			m_searchParam.strSortCol = m_strSortCol;
			m_bSortAscending ? m_searchParam.strSortAsc = L"asc" : m_searchParam.strSortAsc = L"desc";

			DoSearch(m_strSearchText);
		}
	}
}

void CWorkGroupDlg::InitLevels()
{
	NE_LEVEL_DATA_LIST list;
	g_pMessengerActor->GetUserLevels(list);

	m_nSearchLevel = GET_CONFIG()->LoadSearchLevel();
	int nCurSel = 0;

	int nIndex = m_comboLevel.AddString(LoadStringFromResource(IDS_STRING483));
	m_comboLevel.SetItemData(nIndex, 0);
	
	for (size_t i = 0; i < list.nSize; i++)
	{
		NE_LEVEL_DATA level = list.pList[i];

		int nInnerIndex = m_comboLevel.AddString(level.strLevelName.c_str());
		m_comboLevel.SetItemData(nInnerIndex, level.nLevelVal);

		if (level.nLevelVal == m_nSearchLevel)
			nCurSel = i + 1;
	}

	m_comboLevel.SetCurSel(nCurSel);
}

void CWorkGroupDlg::OnCbnSelchangeComboLevel()
{
	int nSel = m_comboLevel.GetCurSel();

	if (nSel != CB_ERR)
	{
		m_nSearchLevel = (int)m_comboLevel.GetItemData(nSel);
		GET_CONFIG()->SaveSearchLevel(m_nSearchLevel);
	}
}

void CWorkGroupDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TIMER_ORG_REQUEST_ORGGROUP)
	{
		KillTimer(TIMER_ORG_REQUEST_ORGGROUP);

		if (GetViewType() == SHOW_ORG && HasAuth(AUTH_SHOW_ORG_TREE) && m_treeOrg.GetCount() == 0)
		{
			m_pController->RequestORGGroup(ADD_WORKORGGROUP);
		}
	}
	else if (nIDEvent == TIMER_ORG_REQUEST_WORKROUP)
	{
		KillTimer(TIMER_ORG_REQUEST_WORKROUP);

		if (GetViewType() == SHOW_WORKGROUP && HasAuth(AUTH_SHOW_WORK_TREE) && m_treeWorkGroup.GetCount() == 0)
		{
			m_pController->RequestWorkGroup();
		}
	}

	__super::OnTimer(nIDEvent);
}

LRESULT CWorkGroupDlg::OnGetBuddyStatus(WPARAM wParam,LPARAM lParam)
{
	int nIndex = (int)wParam;

	if (nIndex < 0)
	{
		return -1;
	}

	const std::vector<ORG_MEMBER_DATA> memberVector = m_pModel->GetMemberVector();
	if (memberVector.size() > nIndex)
	{
		return memberVector[nIndex].eStatus;
	}

	return -1;
}
LRESULT CWorkGroupDlg::OnGetUserStatus(WPARAM wParam,LPARAM lParam)
{
 
// 	CString *pStatus = (CString *)lParam;
// 
// 	int nIndex = (int)wParam;
// 
// 	if (nIndex < 0)
// 	{
// 		return false;
// 	}
// 
// 	const std::vector<ORG_MEMBER_DATA> memberVector = m_pModel->GetMemberVector();
// 	if (memberVector.size() > nIndex)
// 	{
// 		if (ustOFFLINE == memberVector[nIndex].eStatus && GET_CONFIG()->EnableFunction(_T("UI_01")))
// 		{
// 			*pStatus = memberVector[nIndex].neMemberData.strWorkStatus.c_str();
// 		}
// 		else
// 		{
// 			*pStatus = ( GetPresenceTip(memberVector[nIndex].eStatus));
// 		}
// 	}
	
   return TRUE;
}

LRESULT CWorkGroupDlg::OnNcHitTest( CPoint point )
{
	int ret = CDialog::OnNcHitTest(point);
	if((HTTOP == ret || HTBOTTOM == ret || HTLEFT == ret || HTRIGHT == ret || HTBOTTOMLEFT == ret || HTBOTTOMRIGHT == ret || HTTOPLEFT == ret || HTTOPRIGHT == ret) 
		&& m_bMaxWnd)
		return HTCLIENT;
	return ret;
}

int CWorkGroupDlg::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CSkinDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_pWGButtons = new CWorkGroupButtons(this, this);
	m_pWGButtons->LoadSkin();
	
	return 0;
}

BOOL CWorkGroupDlg::SetUserBottomPNGBK(CString strPath)
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetUserBottomBitmapBK(hBitmap);
	m_sizeUserBottomBK		= Global.GetBitmapSize(IDX_BMP_FRAME_USER_BOTTOM_BK);
	m_hBmpUserBottomBK		= Global.GetBitmap(IDX_BMP_FRAME_USER_BOTTOM_BK);

	return TRUE;
}

BOOL CWorkGroupDlg::SetUserBottomPNG(CString strPath)
{
	HBITMAP hBitmap = LoadPngToBmp(strPath);
	if(hBitmap == NULL)
	{
		return FALSE;
	}

	Global.SetUserBottomBitmap(hBitmap);
	m_sizeUserBottom		= Global.GetBitmapSize(IDX_BMP_FRAME_USER_BOTTOM);
	m_hBmpUserBottom		= Global.GetBitmap(IDX_BMP_FRAME_USER_BOTTOM);

	return TRUE;
}

void CWorkGroupDlg::DrawFrame()
{
	//return;
	if (!(GetWindowLong(GetSafeHwnd(), GWL_STYLE) & WS_CAPTION) || (!IsWindow(m_hWnd)))
		return;

	int x = 0, y = 0, x2 = 0, y2 = 0, cx = 0, cy = 0;

	CRect rc(0, 0, 0, 0);
	GetWindowRect(&rc);
	CRect rtPS(0, 0, 0, 0);
	rtPS.right = rc.Width();
	rtPS.bottom = rc.Height();

	BOOL bIconic = IsIconic();
	BOOL bZoomed = IsZoomed();

	CWindowDC dc(this);	

	CDC BufferDC, tmpDC;
	BufferDC.CreateCompatibleDC(&dc);
	tmpDC.CreateCompatibleDC(&dc);

	CBitmap bmpBuffer, *pOldBitmap1 = NULL;
	HGDIOBJ hgdiobj;

	bmpBuffer.CreateCompatibleBitmap(&dc, rc.Width(), rc.Height());
	pOldBitmap1 = (CBitmap*)BufferDC.SelectObject(&bmpBuffer);

	if (bZoomed)
	{
		x = 0;
		y = 0;
	}
	else
	{
		x = 0;
		y = 0;
	}

	cx = m_sizeCapL.cx;
	cy = m_sizeCapL.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapL);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = rc.Width() - m_sizeCapL.cx - m_sizeCapR.cx;
	cy = m_sizeCapM.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapM);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeCapM.cx, m_sizeCapM.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	cx = m_sizeCapR.cx;
	cy = m_sizeCapR.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpCapR);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = 0;
	y = m_sizeCapL.cy;
	cx = m_sizeFrmL.cx;
	cy = rc.Height() - m_sizeCapL.cy - m_sizeFrmB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmL);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmL.cx, m_sizeFrmL.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	

	y += cy;
	cx = m_sizeFrmLB.cx;
	cy = m_sizeFrmLB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmLB);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x += cx;
	y = rc.Height() - m_sizeUserBottomBK.cy;
	cx = rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx;
	cy = m_sizeUserBottomBK.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpUserBottomBK);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeUserBottomBK.cx, m_sizeUserBottomBK.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = (rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx - 2) / 3 + m_sizeFrmL.cx;//m_sizeFrmL.cx + m_pWGButtons->GetUserBottomPos(0);
	cx = 1;
	hgdiobj = tmpDC.SelectObject(m_hBmpUserBottom);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeUserBottom.cx, m_sizeUserBottom.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = (rc.Width() - m_sizeFrmL.cx - m_sizeFrmR.cx - 2) / 3 * 2 + m_sizeFrmL.cx + 1;
	hgdiobj = tmpDC.SelectObject(m_hBmpUserBottom);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeUserBottom.cx, m_sizeUserBottom.cy,  SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	

	x = rc.Width() - m_sizeFrmR.cx;
	y = m_sizeCapR.cy;
	cx = m_sizeFrmR.cx;
	cy = rc.Height() - m_sizeCapR.cy - m_sizeFrmRB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmR);
	BufferDC.StretchBlt(x, y, cx, cy, &tmpDC, 0, 0, m_sizeFrmR.cx, m_sizeFrmR.cy, SRCCOPY);
	tmpDC.SelectObject(hgdiobj);

	x = rc.Width() - m_sizeFrmRB.cx;
	y += cy;
	cx = m_sizeFrmRB.cx;
	cy = m_sizeFrmRB.cy;
	hgdiobj = tmpDC.SelectObject(m_hBmpFrmRB);
	BufferDC.BitBlt(x, y, cx, cy, &tmpDC, 0, 0, SRCCOPY);	
	tmpDC.SelectObject(hgdiobj);


	if (!bIconic)
	{
		if (bZoomed)
			::DrawIconEx(BufferDC.m_hDC, 15, 14, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);
		else
			::DrawIconEx(BufferDC.m_hDC, 15, 5, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);

		if (bZoomed)
			y = GetSystemMetrics(SM_CYFRAME);
		else
			y = (m_sizeCapM.cy - m_sizeBox.cy) / 2;	//!

		hgdiobj = tmpDC.SelectObject(m_hBmpExit);
		x = rc.Width() - MARGIN_BOX - DEF_BTN_MARGIN_RIGHT_POS_X - m_sizeBox.cx;
		BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		if (m_hBmpMaximize)
		{
			if (!m_bMaxWnd)
			{
				hgdiobj = tmpDC.SelectObject(m_hBmpMaximize);
				x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;			
				BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
				tmpDC.SelectObject(hgdiobj);
			}
			else
			{
				hgdiobj = tmpDC.SelectObject(m_hBmpRestore);
				x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;			
				BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
				tmpDC.SelectObject(hgdiobj);
			}
		}

		if (m_hBmpMinimize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpMinimize);
			x = x - DEF_SYSTEM_BTN_GAP - m_sizeBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpCustom && m_bShowCustomBtn)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpCustom);
			x = x - DEF_SYSTEM_BTN_GAP - m_sizeCustomBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeCustomBox.cx, m_sizeCustomBox.cy, &tmpDC, 0, 0, SRCCOPY);
			m_rcCustomBox.left = x;
			m_rcCustomBox.right = x + m_sizeCustomBox.cx;
			m_rcCustomBox.top = y;
			m_rcCustomBox.bottom = y + m_sizeCustomBox.cy;
			tmpDC.SelectObject(hgdiobj);
		}
	}
	else
	{
		::DrawIconEx(BufferDC.m_hDC, 15, 5, m_hIcon, 16, 16, 0, NULL, DI_NORMAL);

		hgdiobj = tmpDC.SelectObject(m_hBmpExit);
		x = rc.Width() - MARGIN_BOX - m_sizeBox.cx;
		BufferDC.BitBlt(x, MARGIN_BOX, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
		tmpDC.SelectObject(hgdiobj);

		if (m_hBmpMaximize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpMaximize);
			x = x - m_sizeBox.cx;		
			BufferDC.BitBlt(x, MARGIN_BOX, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpMinimize)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpRestore);
			x = x - m_sizeBox.cx;		
			BufferDC.BitBlt(x, MARGIN_BOX, m_sizeBox.cx, m_sizeBox.cx, &tmpDC, 0, 0, SRCCOPY);
			tmpDC.SelectObject(hgdiobj);
		}

		if (m_hBmpCustom && m_bShowCustomBtn)
		{
			hgdiobj = tmpDC.SelectObject(m_hBmpCustom);
			x = x - m_sizeCustomBox.cx;		
			BufferDC.BitBlt(x, y, m_sizeCustomBox.cx, m_sizeCustomBox.cx, &tmpDC, 0, 0, SRCCOPY);	
			m_rcCustomBox.left = x;
			m_rcCustomBox.right = x + m_sizeCustomBox.cx;
			m_rcCustomBox.top = y;
			m_rcCustomBox.bottom = y + m_sizeCustomBox.cy;

			tmpDC.SelectObject(hgdiobj);
		}
	}

	tmpDC.DeleteDC();

	BufferDC.SetBkMode(TRANSPARENT);

	CFont* font = GetFont();	
	CFont* pOldFont = NULL;

	if (!m_fntBold.GetSafeHandle() && font)
	{
		LOGFONT logFont;
		font->GetLogFont(&logFont);
		logFont.lfWeight = FW_BOLD;
		m_fntBold.CreateFontIndirect(&logFont);		
	}

	if (m_fntBold.GetSafeHandle())
		pOldFont = (CFont*)BufferDC.SelectObject(&m_fntBold);

	BufferDC.SetTextColor(m_cfText);

	BufferDC.SetTextAlign(TA_LEFT | TA_TOP);

	CString strTitle = _T("");
	GetWindowText(strTitle);
	if (!bIconic && pOldFont)
	{
		CRect rcTitle = rc;

		if (bZoomed)
		{
			rcTitle.left = 10;
			rcTitle.top = 10;				
		}
		else
		{
			rcTitle.left = 5;
			rcTitle.top = 5;
		}
		rcTitle.right = rc.Width() - (m_sizeBox.cx * 3) - 35;
		rcTitle.bottom = rcTitle.top + 15;

		LOGFONT lg;
		pOldFont->GetLogFont(&lg);
		if (strTitle.GetLength() * lg.lfWidth + 20 >= rcTitle.Width())
			strTitle = strTitle.Left(rcTitle.Width() / lg.lfWidth - 5) + _T("...");

		if (m_bShowTitle)
			BufferDC.DrawText(strTitle, rcTitle, DT_LEFT | DT_SINGLELINE|DT_NOPREFIX);

		x = m_sizeFrmL.cx;
		y = m_sizeCapM.cy;
		x2 = rc.Width() - m_sizeFrmR.cx;
		y2 = rc.Height() - m_sizeFrmB.cy;	
		dc.ExcludeClipRect(x, y, x2, y2);
	}
	else
	{
		if (strTitle.GetLength() > 4)
			strTitle = strTitle.Left(4) + _T("...");

		if (m_bShowTitle)
			BufferDC.TextOut(30, (rc.Height() - dc.GetTextExtent(strTitle).cy) / 2, strTitle);
	}

	if (m_bWindowText)
	{
		Graphics graph(BufferDC.GetSafeHdc());

		graph.SetSmoothingMode(SmoothingModeAntiAlias);
		graph.SetInterpolationMode(InterpolationModeHighQualityBicubic);
		graph.SetPageUnit(UnitPixel);

		CRect rtTitle(0, 0, 0, 0);
		CString strDisplay;
		strDisplay = m_strWindowText;
		if(m_strWindowText.GetLength() > MAXIMUM_TITLE_LENGTH)
		{
			strDisplay = m_strWindowText.Left(MAXIMUM_TITLE_LENGTH);
			strDisplay += _T("...");
		}

		REAL fontHeight = m_nTextFontHeight;
		Gdiplus::Font myFont(g_defaultFontFaceName, fontHeight, FontStyleRegular,UnitPixel);
		StringFormat format;
		format.SetAlignment(StringAlignmentNear);
		format.SetLineAlignment(StringAlignmentNear);
		format.SetFormatFlags(0);		
		format.SetTrimming(StringTrimmingEllipsisCharacter);

		SolidBrush brush(m_clrText);

		RectF rSize;
		RectF layoutRect(10, 1, MAXIMUM_TITLE_WIDTH, m_sizeCapM.cy);		
		graph.MeasureString(strDisplay, strDisplay.GetLength(), &myFont, layoutRect, &format, &rSize);

		rSize.Height;
		layoutRect.Y = (float)(layoutRect.Height - rSize.Height)/2 + layoutRect.Y;
		layoutRect.Height = rSize.Height;
		if (layoutRect.Width < MINIMUM_TITLE_WIDTH)
		{
			layoutRect.Width = MINIMUM_TITLE_WIDTH;
		}


		graph.SetPageUnit(UnitPixel);
		graph.DrawString(strDisplay,
			strDisplay.GetLength(),
			&myFont,
			layoutRect,
			&format,
			&brush);

		// 		DrawTextToDest2(&graph,
		// 			strDisplay, &rtPS, &rtTitle,
		// 			g_defaultFontFaceName, 10,
		// 			StringAlignmentNear,
		// 			FontStyleRegular,
		// 			Color(255, 34, 34, 34));
	}


	dc.BitBlt(0, 0, rc.Width(), rc.Height(), &BufferDC, 0, 0, SRCCOPY);

	if (pOldFont)
		BufferDC.SelectObject(pOldFont);

	BufferDC.SelectObject(pOldBitmap1);
	BufferDC.DeleteDC();

}

void CWorkGroupDlg::OnButtonClicked( CWorkGroupButtons::BUTTONS button )
{
	ASSERT(button != CWorkGroupButtons::All);

	if(button == CWorkGroupButtons::Add)
	{
		OnBnClickedFavoriteAddButton();
	}
	else if(button == CWorkGroupButtons::Chat)
	{
		OnBnClickedChatButton();
	}
	else if(button == CWorkGroupButtons::Memo)
	{
		OnBnClickedMemoButton();
	}
	else
	{
		ASSERT(FALSE);
	}
}


	
